<?php
/*---------------------------------------------\
|											   |
| Author:       Andrey Brykin (Drunya)         |
| Version:      1.3.1                          |
| Project:      CMS                            |
| package       CMS Fapos                      |
| subpackege    Foto Module                    |
| copyright     ©Andrey Brykin 2010-2011       |
|----------------------------------------------|
|											   |
| any partial or not partial extension         |
| CMS Fapos,without the consent of the         |
| author, is illegal                           |
|----------------------------------------------|
| Любое распространение                        |
| CMS Fapos или ее частей,                     |
| без согласия автора, является не законным    |
\---------------------------------------------*/







Class FotoModule extends Module {

	/**
	* @module_title  title of module
	*/
	var $module_title = 'Фото';
	/**
	* @template  layout for module
	*/
	var $template = 'foto';
	/**
	* @module module indentifier
	*/
	var $module = 'foto';


	
	/**
	* default action ( show main page )
	*/
	function index() {
		//turn access
		$this->ACL->turn(array('foto', 'view_list'));
		
		//формируем блок со списком  разделов
		if ($this->cached && $this->Cache->check('category_' . $this->cacheKey)) {
			$this->categories = $this->Cache->read('category_' . $this->cacheKey);
		} else {
			$sql_cat = $this->DB->select('foto_sections', DB_ALL, array('cond' => array('class' => 'section')));
			//выводим поочередно все разделы, каждый с новой строки(формируем список)
			foreach ($sql_cat as $result) {
				$this->categories .= '<li>' . get_link(h($result['title']), '/foto/section/' . $result['id']) . '</li>';
			}
			if ($this->cached)
				$this->Cache->write($this->categories, 'category_' . $this->cacheKey, array('module_foto', 'category_block'));
		}
		
		
		//check content cache
		if ($this->cached && $this->Cache->check($this->cacheKey)) {
			$html = $this->Cache->read($this->cacheKey);
		} else {
			//Узнаем кол-во материалов в БД
			$total = $this->DB->select('foto', DB_COUNT);
			$cntPages = ceil( $total / Config::read('per_page', 'foto') );
			if ( isset($_GET['page']) ) {
				$page = (int)$_GET['page'];
				if ( $page < 1 ) $page = 1;
			} else {
				$page = $cntPages;
			}
			if ( $page > $cntPages ) $page = $cntPages;
			if ( $cntPages > 1 ) {
				$pages = pagination( $page, $cntPages, '/foto/');
			} else {
				$pages = '&nbsp;';
			}

			if($total > 0) {
				$html = '';
				// get data
				$sql = $this->DB->select('foto', DB_ALL, array(
					'joins' => array(
						array(
							'table' => 'foto_sections',
							'type' => 'LEFT',
							'alias' => 'b',
							'cond' => 'a.`category_id` = b.`id`',
						),
						array(
							'table' => 'foto_sections',
							'type' => 'LEFT',
							'alias' => 'c',
							'cond' => 'b.`section_id` = c.`id`',
						),
						array(
							'table' => 'users',
							'type' => 'LEFT',
							'alias' => 'd',
							'cond' => 'd.`id` = a.`author_id`',
						),
					),
					'fields' => array('a.*', 'b.`title` as category_name', 'b.`section_id` as section_id', 'c.`title` as section_name', 'd.`name` AS author'),
					'alias' => 'a',
					'order' => 'a.`date` DESC',
					'page' => $page,
					'limit' => Config::read('per_page', 'foto'),
				));
				
				//ITERATION RECORDS
				foreach ($sql as $result) {
					$markets = array();
					$result = $this->Parser->quoteTags($result);
					$htmlfotos = $this->Parser->getAndParse('tablemat.html');
					
					$markets['{MODER_PANEL}'] = $this->_getAdminBar($result);
					$markets['{PREVIEW_FOTO}'] = get_url('/sys/files/foto/preview/' . $result['id'] . '.jpg');
					$markets['{MODER_PANEL}'] = $this->_getAdminBar($result);
					foreach ($result as $key => $value) {
						$markets['{'.strtoupper($key).'}'] = h($value);
					}
					$entry_url = get_url(entryUrl($result, $this->module));
					$markets['{ENTRY_URL}'] = $entry_url;
					$markets['{CATEGORY_URL}'] = get_url('/foto/category/' . $result['category_id']);
					$markets['{PROFILE_URL}'] = getProfileUrl($result['author_id']); 
					$html .= $this->_replaceMarkets($markets, $htmlfotos);

					
					//set cache tags
					$this->setCacheTag(array(
						'record_id_' . $result['id'],
						'user_id_' . $result['author_id'],
					));
				}
			} else {
				$html = __('Materials not found');
			}
			
			
			$materials_tpl = $this->Parser->getAndParse('materials_container.html');
			$markets = array(
				'{MATERIALS}' => $html,
			);
			$html = $this->_replaceMarkets($markets, $materials_tpl);
			
			
			//navigation panel
			$navi = array();
			$navi['{ADD_LINK}'] = ($this->ACL->turn(array('foto', 'add_materials'), false)) 
				? get_link(__('Add material'), '/foto/add_form/') : '';
			$navi['{NAVIGATION}'] = get_link(__('Home'), '/') . __('Separator') . h($this->module_title);
			$navi['{PAGINATION}'] = $pages;
			$navi['{META}'] = __('Count all material') . $total;
			$this->_globalize($navi);


			//save cache
			if ($this->cached) $this->Cache->write($html, $this->cacheKey, $this->cacheTags);
		}
		return $this->_view($html);
	}


	

	 
	function category($id = null) {
		//turn access
		$this->ACL->turn(array('foto', 'view_list'));
		$id = intval($id);
		if (empty($id) || $id < 1) redirect('/');
		
		
		//формируем блок со списком  разделов
		if ($this->cached && $this->Cache->check('category_' . $this->cacheKey)) {
			$this->categories = $this->Cache->read('category_' . $this->cacheKey);
		} else {
			$sql_cat = $this->DB->select('foto_sections', DB_ALL, array(
				'joins' => array(
					array(
						'table' => 'foto_sections',
						'type' => '',
						'alias' => 'b',
						'cond' => '`b`.`section_id` = `a`.`section_id`',
					),
				),
				'alias' => 'a',
				'cond' => array('`a`.`id`' => $id),
			));
			//выводим поочередно все разделы, каждый с новой строки(формируем список)
			foreach ($sql_cat as $result) {
				$this->categories .= '<li>' . get_link(h($result['title']), '/foto/category/' . $result['id']) . '</li>';
			}
			if ($this->cached)
				$this->Cache->write($this->categories, 'category_' . $this->cacheKey, array('module_foto', 'category_block'));
		}
		
		
		
		if ($this->cached && $this->Cache->check($this->cacheKey)) {
			$html = $this->Cache->read($this->cacheKey);
		} else {
		
		
			$total    = $this->DB->select('foto', DB_COUNT, array('cond' => array('category_id' => $id)));
			$cntPages = ceil( $total / Config::read('per_page', 'foto') );
			if ( isset($_GET['page']) ) {
				$page = (int)$_GET['page'];
				if ( $page < 1 ) $page = 1;
			} else {
				$page = $cntPages;
			}
			if ( $page > $cntPages ) $page = $cntPages;
			if ( $cntPages > 1 ) {
				$pages = pagination( $page, $cntPages, '/foto/category/' . $id );
			} else {
				$pages = '&nbsp;';
			}
			
			
			if ($total > 0) {
				$html = '';
				// get data 
				$sql = $this->DB->select('foto', DB_ALL, array(
					'joins' => array(
						array(
							'table' => 'foto_sections',
							'type' => 'LEFT',
							'alias' => 'b',
							'cond' => 'a.`category_id` = b.`id`',
						),
						array(
							'table' => 'foto_sections',
							'type' => 'LEFT',
							'alias' => 'c',
							'cond' => 'b.`section_id` = c.`id`',
						),
						array(
							'table' => 'users',
							'type' => 'LEFT',
							'alias' => 'd',
							'cond' => 'd.`id` = a.`author_id`',
						),
					),
					'fields' => array('a.*', 'b.`title` as category_name', 'b.`section_id` as section_id', 'c.`title` as section_name', 'd.`name` AS author'),
					'alias' => 'a',
					'cond' => array('`a`.`category_id`' => $id),
					'order' => 'a.`date` DESC',
					'page' => $page,
					'limit' => Config::read('per_page', 'foto'),
				));
				
				
				//ITERATION RECORDS
				foreach ($sql as $result) {
					$markets = array();
					$result = $this->Parser->quoteTags($result);
					$htmlfotos = $this->Parser->getAndParse('tablemat.html');

					$markets['{MODER_PANEL}'] = $this->_getAdminBar($result);
					$markets['{PREVIEW_FOTO}'] = get_url('/sys/files/foto/preview/' . $result['id'] . '.jpg');
					foreach ($result as $key => $value) {
					   $markets['{'.strtoupper($key).'}'] = h($value);
					}
					$markets['{ENTRY_URL}'] = get_url('/foto/view/' . $result['id']);
					$markets['{CATEGORY_URL}'] = get_url('/foto/category/' . $result['category_id']);
					$markets['{PROFILE_URL}'] = getProfileUrl($result['author_id']);
					$html .= $this->_replaceMarkets($markets, $htmlfotos);

					
					//set cache tags
					$this->setCacheTag(array(
						'record_id_' . $result['id'],
						'user_id_' . $result['author_id'],
						'category_id_' . $id,
					));
				}
				
			} else {
				$html = __('Materials not found');
			}
			
			
			$materials_tpl = $this->Parser->getAndParse('materials_container.html');
			$markets = array(
				'{MATERIALS}' => $html,
			);
			$html = $this->_replaceMarkets($markets, $materials_tpl);
			
			
			//navigation panel
			$category_info = $this->DB->select('foto_sections', DB_FIRST, array(
				'joins' => array(
					array(
						'table' => 'foto_sections',
						'alias' => 'b',
						'type' => 'LEFT',
						'cond' => '`b`.`id` = `a`.`section_id`',
					),
				),
				'alias' => 'a',
				'cond' => array('`a`.`id`' => $id),
				'fields' => array('a.`title` as ctitle', 'a.`id` as cid', 'b.`title` as stitle', 'b.`id` as sid'),
			));
			
			
			//navigation panel
			$navi = array();
			$navi['{ADD_LINK}'] = ($this->ACL->turn(array('foto', 'add_materials'), false)) 
				? get_link(__('Add material'), '/foto/add_form/') : '';
			$navi['{NAVIGATION}'] = get_link(__('Home'), '/') 
				. __('Separator') . get_link(h($this->module_title)
				, '/foto/') . __('Separator') . get_link(h($category_info[0]['stitle'])
				, '/foto/section/' . $category_info[0]['sid']) . __('Separator') . h($category_info[0]['ctitle']);
			$navi['{PAGINATION}'] = $pages;
			$navi['{META}'] = __('Count material in cat') . $total;
			$this->_globalize($navi);
			
		
			//write cache
			if ($this->cached)
				$this->Cache->write($html, $this->cacheKey, $this->cacheTags);
		}
		return $this->_view($html);
	}
	  
	  
	  
 
	  
	  
	function section($id = null) {
		//turn access
		$this->ACL->turn(array('foto', 'view_list'));
		$id = intval($id);
		if (empty($id) || $id < 1) redirect('/');
		
		
		//формируем блок со списком  разделов
		if ($this->cached && $this->Cache->check('category_' . $this->cacheKey)) {
			$this->categories = $this->Cache->read('category_' . $this->cacheKey);
		} else {
			$sql_cat = $this->DB->select('foto_sections', DB_ALL, array('cond' => array('class' => 'category', 'section_id' => $id)));
			//выводим поочередно все разделы, каждый с новой строки(формируем список)
			foreach ($sql_cat as $result) {
				$this->categories .= '<li>' . get_link(h($result['title']), '/foto/category/' . $result['id']) . '</li>';
			}
			if ($this->cached)
				$this->Cache->write($this->categories, 'category_' . $this->cacheKey, array('module_foto', 'category_block'));
		}
		
		
		
		if ($this->cached && $this->Cache->check($this->cacheKey)) {
			$html = $this->Cache->read($this->cacheKey);
		} else {
		
		
			$total = $this->DB->select('foto', DB_COUNT, array('cond' => array('section_id' => $id)));
			$cntPages = ceil( $total / Config::read('per_page', 'foto') );
			if ( isset($_GET['page']) ) {
				$page = (int)$_GET['page'];
				if ( $page < 1 ) $page = 1;
			} else {
				$page = $cntPages;
			}
			if ( $page > $cntPages ) $page = $cntPages;
			if ( $cntPages > 1 ) {
				$pages = pagination( $page, $cntPages, '/foto/section/' . $id . '');
			} else {
				$pages = '&nbsp;';
			}
			
			
			if ($total > 0) {
				$html = '';
				// get data 
				$sql = $this->DB->select('foto', DB_ALL, array(
					'joins' => array(
						array(
							'table' => 'foto_sections',
							'type' => 'LEFT',
							'alias' => 'b',
							'cond' => 'a.`category_id` = b.`id`',
						),
						array(
							'table' => 'foto_sections',
							'type' => 'LEFT',
							'alias' => 'c',
							'cond' => 'b.`section_id` = c.`id`',
						),
						array(
							'table' => 'users',
							'type' => 'LEFT',
							'alias' => 'd',
							'cond' => 'd.`id` = a.`author_id`',
						),
					),
					'fields' => array('a.*', 'b.`title` as category_name', 'b.`section_id` as section_id', 'c.`title` as section_name', 'd.`name` AS author'),
					'alias' => 'a',
					'cond' => array('`a`.`section_id`' => $id),
					'order' => 'a.`date` DESC',
					'page' => $page,
					'limit' => Config::read('per_page', 'foto'),
				));
				
				//ITERATION RECORDS
				foreach ($sql as $result) {
					$markets = array();
					$result = $this->Parser->quoteTags($result);
					$htmlfotos = $this->Parser->getAndParse('tablemat.html');

					$markets['{MODER_PANEL}'] = $this->_getAdminBar($result);
					$markets['{PREVIEW_FOTO}'] = get_url('/sys/files/foto/preview/' . $result['id'] . '.jpg');
					foreach ($result as $key=>$value) {
					   $markets['{'.strtoupper($key).'}'] = h($value);
					}
					$markets['{ENTRY_URL}'] = get_url('/foto/view/' . $result['id']);
					$markets['{CATEGORY_URL}'] = get_url('/foto/category/' . $result['category_id']);
					$markets['{PROFILE_URL}'] = getProfileUrl($result['author_id']);
					$html .= $this->_replaceMarkets($markets, $htmlfotos);
					

					//set cache tags
					$this->setCacheTag(array(
						'record_id_' . $result['id'],
						'user_id_' . $result['author_id'],
						'section_id_' . $id,
					));
				}
			} else {
				$html = __('Materials not found');
			}
			
			
			$materials_tpl = $this->Parser->getAndParse('materials_container.html');
			$markets = array(
				'{MATERIALS}' => $html,
			);
			$html = $this->_replaceMarkets($markets, $materials_tpl);
			
			
			//navigation panel
			$navi = array();
			$section_info = $this->DB->select('foto_sections', DB_FIRST, array(
				'cond' => array(
					'id' => $id,
					'class' => 'section', 
				)
			));
			
			$navi['{NAVIGATION}'] = get_link(__('Home'), '/') . __('Separator') 
			. get_link(h($this->module_title), '/foto/');
			if (!empty($section_info[0])) $navi['{NAVIGATION}'] .= __('Separator') . h($section_info[0]['title']);
			$navi['{ADD_LINK}'] = ($this->ACL->turn(array('foto', 'add_materials'), false)) 
				? get_link(__('Add material'), '/foto/add_form/') : '';
			$navi['{PAGINATION}'] = $pages;
			$navi['{META}'] = __('Count material in cat') . $total;
			$this->_globalize($navi);
			
			
			
			//write cache
			if ($this->cached)
				$this->Cache->write($html, $this->cacheKey, $this->cacheTags);
		}
		return $this->_view($html);
	}
	  
	  

	  


	function view ($id = null) {
		//turn access
		$this->ACL->turn(array('foto', 'view_materials'));
		$id = intval($id);
		if (empty($id) || $id < 1) redirect('/');
		
		
		//  в другом случае извлекаем шаблон отображения материала
		$html = $this->Parser->getAndParse('viewmat.html');
		$markets = array();

		
		// извлекаем из БД информацию материала
		$sql = $this->DB->select('foto', DB_ALL, array(
			'joins' => array(
				array(
					'table' => 'foto_sections',
					'type' => 'LEFT',
					'alias' => 'b',
					'cond' => 'a.`category_id` = b.`id`',
				),
				array(
					'table' => 'foto_sections',
					'type' => 'LEFT',
					'alias' => 'c',
					'cond' => 'b.`section_id` = c.`id`',
				),
				array(
					'table' => 'users',
					'type' => 'LEFT',
					'alias' => 'd',
					'cond' => 'd.`id` = a.`author_id`',
				),
			),
			'fields' => array('a.*', 'b.`title` as category_name', 'b.`section_id` as section_id', 'c.`title` as section_name', 'd.`name` AS author', 'd.`status` AS author_status'),
			'alias' => 'a',
			'cond' => array('`a`.`id`' => $id),
		));
		if (count($sql) < 1) return $this->_view(__('Some error occurred'));
		$result = $this->Parser->quoteTags($sql[0]);
		
		$next_prev = $this->DB->query("SELECT 
			(SELECT `id` FROM `" . $this->DB->getFullTableName('foto') . "` 
			WHERE `id` < " . $id . " ORDER BY `id` DESC LIMIT 1) as prev,
			(SELECT `id` FROM `" . $this->DB->getFullTableName('foto') . "` 
			WHERE `id` > " . $id . " ORDER BY `id` LIMIT 1) as next
			FROM `" . $this->DB->getFullTableName('foto') . "` LIMIT 1");
			
			
		//строим и выводим навигацию по секциям и категориям
		$markets['MODULE_URL'] = get_url('/foto/');
		$markets['SECTION_URL'] = get_url('/foto/section/' . $result['section_id']);
		$markets['SECTION_NAME'] = h($result['section_name']);
		$markets['CATEGORY_URL'] = get_url('/foto/category/' . $result['category_id']);
		$markets['CATEGORY_NAME'] = h($result['category_name']);
		$this->_globalize($markets); $markets = array();


		
		
		$markets['{MODER_PANEL}'] = $this->_getAdminBar($result);
		$markets['{MAIN}'] = get_url('/sys/files/foto/full/' . $result['id'] . '.jpg');
		$markets['{DESCRIPTION}'] = $this->Textarier->print_page($result['description'], $result['author_status']);
		
		foreach ($result as $key => $value) {
			$markets['{'.strtoupper($key).'}'] = h($value);
		}

		$markets['{PROFILE_URL}'] = getProfileUrl($result['author_id']);
		$markets['{PROFILE_URL}'] = getProfileUrl($result['author_id']);
		$prev_id = (!empty($next_prev[0]['prev']) && $next_prev[0]['prev'] > 0) ? $next_prev[0]['prev'] : $id;
		$next_id = (!empty($next_prev[0]['next']) && $next_prev[0]['next'] > 0) ? $next_prev[0]['next'] : $id;
		$markets['{PREVIOUS_URL}'] = get_url('/foto/view/' . $prev_id);
		$markets['{NEXT_URL}'] = get_url('/foto/view/' . $next_id);
		$html = $this->_replaceMarkets($markets, $html);


		$this->DB->save('foto', array(
			'`views` = `views` + 1',
			'id' => $id
		));
		$this->page_title = $this->page_title . '-' . h($result['title']);
		
		
		
		//формируем блок со списком  разделов
		if ($this->cached && $this->Cache->check('category_' . $this->cacheKey)) {
			$this->categories = $this->Cache->read('category_' . $this->cacheKey);
		} else {
			$cats = $this->DB->select('foto_sections', DB_ALL, array('cond' => array('section_id' => $result['section_id'])));
			//выводим поочередно все разделы, каждый с новой строки(формируем список)
			foreach ($cats as $result) {
				$this->categories .= '<li>' . get_link(h($result['title']), '/foto/category/' . $result['id']) . '</li>';
			}
			if ($this->cached)
				$this->Cache->write($this->categories, 'category_' . $this->cacheKey, array('module_foto', 'category_block'));
		}
		
		$this->DB->cleanSqlCache();
		
		return $this->_view($html);
	}





	/**
	 * 
	 * Create form and fill his data from SESSION['FpsForm']
	 * or SESSION['previewMessage'] if an exists. 
	 * Show errors if an exists after unsuccessful attempt.
	 *
	 */
	function add_form () {
		//turn access
		$this->ACL->turn(array('foto', 'add_materials'));

		
		//формируем блок со списком  разделов
		if ($this->cached && $this->Cache->check('category_' . $this->cacheKey)) {
			$this->categories = $this->Cache->read('category_' . $this->cacheKey);
		} else {
			//формируем блок со списком  разделов
			$sql_cat = $this->DB->select('foto_sections', DB_ALL, array('cond' => array('class' => 'section')));
			//выводим поочередно все разделы, каждый с новой строки(формируем список)
			foreach ($sql_cat as $result) {
				$this->categories .= '<li>' . get_link(h($result['title']), '/foto/section/' . $result['id']) . '</li>';
			}
			if ($this->cached)
				$this->Cache->write($this->categories, 'category_' . $this->cacheKey, array('module_foto', 'category_block'));
		}
		
		
		$html = null;
		$markets = array();
		
		//categories list
		$sql = $this->DB->select('foto_sections', DB_ALL, array('cond' => array('class' => 'section')));
		$cats_change = '';
		foreach ($sql as $fetch) {
			$cats_change .= "<option disabled='disabled'>" . h($fetch['title']) . "</option>";
			$categories   = $this->DB->select('foto_sections', DB_ALL, array('cond' => array('section_id' => $fetch['id'])));
			foreach ($categories as $fetch_cat) {
				$cats_change .= "<option value=\"" . $fetch_cat['id'] . "\" />" . h($fetch_cat['title']) . "</option>";
			}
		}
		
		// Если при заполнении формы были допущены ошибки
		if ( isset( $_SESSION['addForm'] ) ) {
			$info      		= $this->Parser->getAndParse('infomessage.html' );
			$info      		= str_replace( '{INFO_MESSAGE}', $_SESSION['addForm']['error'], $info );
			$html      		= $html . $info . "\n";
			$title          = h( $_SESSION['addForm']['title'] );
			$description    = h( $_SESSION['addForm']['description'] );
			unset( $_SESSION['addForm'] );
		}

		$markets['{ACTION}'] = get_url('/foto/add/');
		$html = $html . $this->Parser->getAndParse('addform.html' );
		$markets['{CATS_SELECTOR}'] = $cats_change;
		$markets['{TITLE}'] = (!empty($title)) ? $title : '';
		$markets['{MAIN_TEXT}'] = (!empty($$description)) ? $$description : '';
		$html = $this->_replaceMarkets($markets, $html);
		
		
		// Navigation Panel
		$navi['{NAVIGATION}'] = get_link(__('Home'), '/') . __('Separator') 
			. get_link(h($this->module_title), '/foto/')
			. __('Separator') . __('Adding material');
		$navi['{ADD_LINK}'] = ($this->ACL->turn(array('foto', 'add_materials'), false)) 
			? get_link(__('Add material'), '/foto/add_form/') : '';
		$this->_globalize($navi);
		
		
		return $this->_view($html);
	}





	// Функция добавляет новую новость (новую запись в таблицу БД TABLE_NEWS)
	function add() {
		//turn access
		$this->ACL->turn(array('foto', 'add_materials'));
		
		if (!isset($_POST['title']) 
		|| !isset($_FILES['foto']) 
		|| !isset($_POST['cats_selector'])) {
			redirect('/');
		}
		if ( !is_numeric($_POST['cats_selector']) ) {
			redirect('/');
		}


		// Обрезаем переменные до длины, указанной в параметре maxlength тега input
		$title   	 = trim(mb_substr( $_POST['title'], 0, 128 ));
		$description = trim($_POST['mainText']);
		$in_cat 	 = intval($_POST['cats_selector']);


		// Check fields
		$error = '';
		$valobj = new Validate;
		if (empty($in_cat))                          
			$error = $error.'<li>'.__('Category not selected').'</li>'."\n";
		if (empty($title))                           
			$error = $error.'<li>'.__('Empty field "title"').'</li>'."\n";
		elseif (!$valobj->cha_val($title, V_TITLE))  
			$error = $error.'<li>'.__('Wrong chars in "title"').'</li>'."\n";
		if (empty($description) && Config::read('description_requred', 'foto')) {
			$error = $error.'<li>'.__('Empty field "description"').'</li>'."\n";
		}
		if (mb_strlen($description) > Config::read('description_lenght', 'foto'))
			$error = $error .'<li>'.sprintf(__('Wery big "description"'), Config::read('description_lenght', 'foto')).'</li>'."\n";
		
		
		
		/* check file */
		if (empty($_FILES['foto']['name']))	{
			$error = $error .'<li>'.__('Not attaches').'</li>'. "\n";
		} else {
			if ($_FILES['foto']['size'] > Config::read('max_file_size', 'foto')) 
				$error = $error .'<li>'. sprintf(__('Wery big file2'), Config::read('max_file_size', 'foto')/1000) .'</li>'."\n";
			if ($_FILES['foto']['type'] != 'image/jpeg' &&
			$_FILES['foto']['type'] != 'image/gif' &&
			$_FILES['foto']['type'] != 'image/bmp' &&
			$_FILES['foto']['type'] != 'image/png') 
				$error = $error .'<li>'.__('Wrong file format').'</li>'."\n";
		}
		
		
		$sql = $this->DB->select('foto_sections', DB_FIRST, array('cond' => array('id' => $in_cat)));
		if (empty($sql)) $error = $error.'<li>'.__('Can not find category').'</li>'."\n";
		$info_cat = $sql[0];

		// errors
		if ( !empty( $error ) ) {
			$_SESSION['addForm']            = array();
			$_SESSION['addForm']['error']   = '<p class="errorMsg">' . __('Some error in form') . '</p>'.
				"\n".'<ul class="errorMsg">'."\n".$error.'</ul>'."\n";
			$_SESSION['addForm']['title']   = $title;
			$_SESSION['addForm']['description']   = $description;
			redirect('/foto/add_form/');
		}

		// spam protected
		if ( isset( $_SESSION['unix_last_post'] ) and ( time()-$_SESSION['unix_last_post'] < 10 ) ) {
			return showInfoMessage(__('Your message has been added'), '/foto/');
		}
		
		// Формируем SQL-запрос на добавление темы	
		$description = mb_substr($description, 0, Config::read('description_lenght', 'foto'));
		$res = $this->DB->save('foto', array(
			'title'        => $title,
			'description'  => $description,
			'date'         => new Expr('NOW()'),
			'author_id'    => $_SESSION['user']['id'],
			'category_id'  => $info_cat['id'],
			'section_id'  => $info_cat['section_id'],
		));
		$id = mysql_insert_id();
 
 
		/* save full and resample images */
		if (!move_uploaded_file($_FILES['foto']['tmp_name'], R . 'sys/files/foto/full/' . $id . '.jpg')) $error_flag = true; 	
		if (!chmod(R . 'sys/files/foto/full/' . $id . '.jpg', 0644)) $error_flag = true; 
		/* if an error when coping */
		if (!empty($error_flag)) {
			$this->DB->query("DELETE FROM `" . $this->DB->getFullTableName('foto') . "` WHERE `id` = '" . $id . "'");
			$_SESSION['addForm'] = array();
			$_SESSION['addForm']['error'] = '<p class="errorMsg">Произошла ошибка:</p>'
				. "\n" . '<ul class="errorMsg">'."\n".'Неизвесная ошибка. Попробуйте начать заново.</ul>'."\n";
			$_SESSION['addForm']['title'] = $title;
			redirect('/foto/add_form/');
		}
		$resample = resampleImage(R . 'sys/files/foto/full/' . $id . '.jpg', R . 'sys/files/foto/preview/' . $id . '.jpg', 150);
		if ($resample) chmod(R . 'sys/files/foto/preview/' . $id . '.jpg', 0644);
		
		//clean cache
		$this->Cache->clean(CACHE_MATCHING_TAG, array('module_foto'));
		$this->DB->cleanSqlCache();
		if ($this->Log) $this->Log->write('adding foto', 'foto id(' . $id . ')');
		return showInfoMessage(__('Material successful added'), '/foto/' );		  
	}





	/**
	 * 
	 * Create form and fill his data from record which ID
	 * transfered into function. Show errors if an exists
	 * after unsuccessful attempt. Also can get data for filling
	 * from SESSION if user try preview message or create error.
	 *
	 * @param int $id material then to be edit
	 */
	function edit_form($id = null) {	
		$id = intval($id);
		if (empty($id) || $id < 1) redirect('/');
		

		//формируем блок со списком  разделов
		if ($this->cached && $this->Cache->check('category_' . $this->cacheKey)) {
			$this->categories = $this->Cache->read('category_' . $this->cacheKey);
		} else {
			//формируем блок со списком  разделов
			$sql_cat = $this->DB->select('foto_sections', DB_ALL, array('cond' => array('class' => 'section')));
			//выводим поочередно все разделы, каждый с новой строки(формируем список)
			foreach ($sql_cat as $result) {
				$this->categories .= '<li>' . get_link(h($result['title']), '/foto/section/' . $result['id']) . '</li>';
			}
			if ($this->cached)
				$this->Cache->write($this->categories, 'category_' . $this->cacheKey, array('module_foto', 'category_block'));
		}
		
		
		
		// Получаем из БД информацию о редактируемой теме
		$res = $this->DB->select('foto', DB_ALL, array(
			'joins' => array(
				array(
					'table' => 'foto_sections',
					'type' => 'LEFT',
					'alias' => 'b',
					'cond' => 'a.`category_id` = b.`id`',
				),
				array(
					'table' => 'foto_sections',
					'type' => 'LEFT',
					'alias' => 'c',
					'cond' => 'b.`section_id` = c.`id`',
				),
				array(
					'table' => 'users',
					'type' => 'LEFT',
					'alias' => 'd',
					'cond' => 'd.`id` = a.`author_id`',
				),
			),
			'fields' => array('a.*', 'b.`title` as category_name', 'b.`section_id` as section_id', 'c.`title` as section_name', 'd.`name` AS author'),
			'alias' => 'a',
			'cond' => array('`a`.`id`' => $id),
		));
		if (count($res) < 1) return $this->_view(_(23, 'common'));
		$foto = $res[0];
		
		
		
		if (!$this->ACL->turn(array('foto', 'edit_materials')) 
		|| (!empty($_SESSION['user']['id']) && $foto['author_id'] == $_SESSION['user']['id'] 
		&& !$this->ACL->turn(array('foto', 'edit_mine_materials')))) {
			return showInfoMessage(__('Permission denied'), '/foto/' );
		}
		
		
		$html = '';
		$markets = array();
		
		
		// errors
		if ( isset( $_SESSION['editForm'] ) ) {
			$html     		= $html.$_SESSION['editForm']['error'];
			$title    		= h( $_SESSION['editForm']['title'] );
			$description    = h( $_SESSION['editForm']['description'] );
			unset( $_SESSION['editForm'] );
		} else {
			$title    		= h( $foto['title'] );
			$description    = h( $foto['description'] );
		}
		
		
		$sql = $this->DB->select('foto_sections', DB_ALL, array('cond' => array('class' => 'section')));
		$cats_change = '';
		foreach ($sql as $fetch) {
			$cats_change .= "<option disabled='disabled'>".$fetch['title']."</option>";
			$categories   = $this->DB->select('foto_sections', DB_ALL, array('cond' => array('section_id' => $fetch['id'])));
			foreach ($categories as $fetch_cat) {
				if($foto['category_id'] == $fetch_cat['id']) {
					$cats_change .= "<option value=\"" . $fetch_cat['id'] . "\" selected=\"selected\">" . h($fetch_cat['title']) . "</option>";
				} else {
					$cats_change .= "<option value=\"" . $fetch_cat['id'] . "\">" . h($fetch_cat['title']) . "</option>";
				}
			}
		}

		
		$tpl = $this->Parser->getAndParse('editform.html' );
		$markets['{ACTION}'] = get_url('/foto/update/' . $id);
		$markets['{TITLE}'] = $title;
		$markets['{MAIN_TEXT}'] = $description;
		$markets['{CATS_SELECTOR}'] = $cats_change;
		$markets['{AUTHOR_NAME}'] = h($foto['author']);
		
		$markets = $this->Parser->quoteTags($markets);
		$html = $html . $this->_replaceMarkets($markets, $tpl);
		
		
		return $this->_view($html);
	}





	/**
	 * 
	 * Validate data and update record into 
	 * Data Base. If an errors, redirect user to add form
	 * and show error message where speaks as not to admit 
	 * errors in the future
	 * 
	 */
	function update($id = null) {		
		// Если не переданы данные формы - функция вызвана по ошибке
		if (empty( $id ) || !isset( $_POST['title'] ) 
		|| !isset($_POST['cats_selector']) || !is_numeric( $_POST['cats_selector'] )) {
			redirect('/');
		}
		$id = (int)$id;
		if ($id < 1) {
			redirect('/foto/');
		}



		$res = $this->DB->select('foto', DB_ALL, array(
			'joins' => array(
				array(
					'table' => 'foto_sections',
					'type' => 'LEFT',
					'alias' => 'b',
					'cond' => 'a.`category_id` = b.`id`',
				),
				array(
					'table' => 'foto_sections',
					'type' => 'LEFT',
					'alias' => 'c',
					'cond' => 'b.`section_id` = c.`id`',
				),
				array(
					'table' => 'users',
					'type' => 'LEFT',
					'alias' => 'd',
					'cond' => 'd.`id` = a.`author_id`',
				),
			),
			'fields' => array('a.*', 'b.`title` as category_name', 'b.`section_id` as section_id', 'c.`title` as section_name', 'd.`name` AS author'),
			'alias' => 'a',
			'cond' => array('`a`.`id`' => $id),
		));
		if (count($res) < 1) return $this->_view(__('Some error occurred'));
		$foto = $res[0];

		
		if (!$this->ACL->turn(array('foto', 'edit_materials'), false) 
		|| (!empty($_SESSION['user']['id']) && $foto['author_id'] == $_SESSION['user']['id'] 
		&& !$this->ACL->turn(array('foto', 'edit_mine_materials'), false))) {
			return showInfoMessage(__('Permission denied'), '/foto/' );
		}
		
		
		// Обрезаем переменные до длины, указанной в параметре maxlength тега input
		$title       = trim(mb_substr($_POST['title'], 0, 128));
		$description = trim($_POST['mainText']);

		
		// Check fields
		$error = '';
		if ( empty( $title ) )                    
			$error = $error.'<li>'.__('Empty field "title"').'</li>'."\n";
		if (!Validate::cha_val($title, V_TITLE))  
			$error = $error.'<li>'.__('Wrong chars in "title"').'</li>'."\n";
		if (empty($description) && Config::read('description_requred', 'foto')) 
			$error = $error.'<li>'.__('Empty field "description"').'</li>'."\n";
		if (mb_strlen($description) > Config::read('description_lenght', 'foto'))
			$error = $error.'<li>'.sprintf(__('Wery big "description"'), Config::read('description_lenght', 'foto')).'</li>'."\n";
			
		$in_cat = intval($_POST['cats_selector']);
		$sql = $this->DB->select('foto_sections', DB_FIRST, array('cond' => array('id' => $in_cat)));
		if (empty($sql)) $error = $error.'<li>'.__('Can not find category').'</li>'."\n";
		$info_cat = $sql[0];

		
		
		// errors
		if (!empty( $error )) {
			$_SESSION['editForm']            = array();
			$_SESSION['editForm']['error']   = '<p class="errorMsg">' . __('Some error in form') 
			. '</p>'."\n".'<ul class="errorMsg">'."\n".$error.'</ul>'."\n";
			$_SESSION['editForm']['title']         = $title;
			$_SESSION['editForm']['description']   = $description;
			redirect('/foto/edit_form/' . $id );
		}

		
		// Запрос на обновление новости
		$description = mb_substr($description, 0, Config::read('description_lenght', 'foto'));
		$res = $this->DB->save('foto', array(
			'title' 	  => $title,
			'description' => $description,
			'category_id' => $info_cat['id'],
			'id' => $id
		));
		
		
		//clean cache
		$this->Cache->clean(CACHE_MATCHING_TAG, array('module_foto', 'record_id_' . $id));
		$this->DB->cleanSqlCache();
		if ($this->Log) $this->Log->write('editing foto', 'foto id(' . $id . ')');
		return showInfoMessage(__('Operation is successful'), '/foto/' );

	}





	/**
	 * Check user access and if all right
	 * delete record with geting ID.
	 *
	 * @param int $id
	 */
	function delete($id = null) {		
		$id = intval($id);
		if (empty($id) || $id < 1) redirect('/');
		
		
		$sql = $this->DB->select('foto', DB_FIRST, array('cond' => array('id' => $id)));
		if (empty($sql)) return showInfoMessage(__('Some error occurred'), '/foto/' );
		$result = $sql[0];

		if (!$this->ACL->turn(array('foto', 'delete_materials'), false) 
		|| (!empty($_SESSION['user']['id']) && $result['author_id'] == $_SESSION['user']['id'] 
		&& !$this->ACL->turn(array('foto', 'delete_mine_materials'), false))) {
			return showInfoMessage(__('Permission denied'), '/foto/' );
		}
		
		// Теперь удаляем материал 
		$res = $this->DB->query("DELETE FROM `" . $this->DB->getFullTableName('foto') . "` WHERE `id` = '" . $id . "'");	
		if (file_exists(R . 'sys/files/foto/full/' . $id . '.jpg')) unlink(R . 'sys/files/foto/full/' . $id . '.jpg');
		if (file_exists(R . 'sys/files/foto/preview/' . $id . '.jpg')) unlink(R . 'sys/files/foto/preview/' . $id . '.jpg');
		//clean cache
		$this->Cache->clean(CACHE_MATCHING_TAG, array('module_foto'));
		$this->DB->cleanSqlCache();
		if ($this->Log) $this->Log->write('delete foto', 'foto id(' . $id . ')');
		return showInfoMessage(__('Operation is successful'), '/foto/' );
	}


	/**
	* @param int $id - record ID
	*
	* update date by record also up record in recods list
	*/
	public function upper($id) {
		$this->ACL->turn(array('foto', 'up_materials'));
		$this->DB->save('foto', array('id' => $id, 'date' => new Expr('NOW()')));
		return showInfoMessage(__('Operation is successful'), '/foto/');
	}
	

	
	
	
	
	/**
	* @param array $record - record from database
	* @return string - admin buttons
	*
	* create and return admin bar
	*/
	protected function _getAdminBar($record) {
		$moder_panel = '';
		if ($this->ACL->turn(array('foto', 'edit_materials'), false) 
		|| (!empty($_SESSION['user']['id']) && $record['author_id'] == $_SESSION['user']['id'] 
		&& $this->ACL->turn(array('foto', 'edit_mine_materials'), false))) {
			$moder_panel .= get_link(get_img('/sys/img/edit_16x16.png'), '/foto/edit_form/' . $record['id']) . '&nbsp;';
		}
		if ($this->ACL->turn(array('foto', 'up_materials'), false)) {
			$moder_panel .= get_link(get_img('/sys/img/up_arrow_16x16.png'), '/foto/upper/' . $record['id'], 
			array('onClick' => "return confirm('" . __('Are you sure') . "')")) . '&nbsp;';
		}
		if ($this->ACL->turn(array('foto', 'delete_materials'), false) 
		|| (!empty($_SESSION['user']['id']) && $record['author_id'] == $_SESSION['user']['id'] 
		&& $this->ACL->turn(array('foto', 'delete_mine_materials'), false))) {
			$moder_panel .= get_link(get_img('/sys/img/delete_16x16.png'), '/foto/delete/' . $record['id'], 
			array('onClick' => "return confirm('" . __('Are you sure') . "')")) . '&nbsp;';
		}
		return $moder_panel;
	}	
	
}
?>