<?php
/*-----------------------------------------------\
| 												 |
|  Author:       Andrey Brykin (Drunya)          |
|  Version:      1.3.2                           |
|  Project:      CMS                             |
|  package       CMS Fapos                       |
|  subpackege    Pages Module                    |
|  copyright     ©Andrey Brykin 2010-2011        |
\-----------------------------------------------*/

/*-----------------------------------------------\
| 												 |
|  any partial or not partial extension          |
|  CMS Fapos,without the consent of the          |
|  author, is illegal                            |
|------------------------------------------------|
|  Любое распространение                         |
|  CMS Fapos или ее частей,                      |
|  без согласия автора, является не законным     |
\-----------------------------------------------*/



Class PagesModule extends Module {

	/**
	* @module_title  title of module
	*/
	var $module_title;
	/**
	* @template  layout for module
	*/
	//var $template;
	/**
	* @module module indentifier
	*/
	var $module = 'pages';


	
	/**
	* default action
	*/
	function index($id = null, $s =null, $x = null) {
		//if isset ID - we need load page with this ID
		if (!empty($id)) {
			if (!is_numeric($id)) redirect('/pages/');
			$id = (int)$id;
			if ($id < 1)  redirect('/pages/');
		
		
			$content = $this->DB->select('htmlpage', DB_FIRST, array('cond' => array('id' => $id), 'limit' => 1));
			if (empty($content)) return showInfoMessage(__('Can not find this page'), '/');
			
			$this->page_title = $content[0]['name'];
			$this->template = (!empty($content[0]['template'])) ? $content[0]['template'] : 'default';
			$this->Parser->templateDir = $this->template;
			$html = $content[0]['content'];
			$html = $this->Parser->parseString($html);
			return $this->_view($html);
			
		//may be need view latest materials	
		} else {
			$this->page_title = Config::read('title');
			$latest_on_home = Config::read('latest_on_home');
			$navi = null; //vsyakiy sluchay:)
			
			
			//if we want view latest materials on home page
			if (is_array($latest_on_home) && count($latest_on_home) > 0) {
			
				// Navigation Block
				$navi = array();
				$navi['{ADD_LINK}'] = ($this->ACL->turn(array('news', 'add_materials'), false)) 
					? get_link(__('Add material'), '/news/add_form') : '';
				$navi['{NAVIGATION}'] = get_link(__('Home'), '/');
				$this->_globalize($navi);
			
			
				if ($this->cached && $this->Cache->check($this->cacheKey)) {
					$html = $this->Cache->read($this->cacheKey);
				} else {
					
					//create SQL query
					$sql = '';
					if (in_array('news', $latest_on_home)) 
					$sql .= "(SELECT `title`, `main`, `date`, `on_home_top`, `id`, `views`, `author_id`, (SELECT \"news\") AS skey  FROM `" 
						 . $this->DB->getFullTableName('news') . "` "
						 . "WHERE `view_on_home` = '1' AND `available` = '1') ";
					if (in_array('loads', $latest_on_home)) {
						if (!empty($sql)) $sql .= 'UNION ';
						$sql .= "(SELECT `title`, `main`, `date`, `on_home_top`, `id`, `views`, `author_id`, (SELECT \"loads\") AS skey   FROM `" 
							 . $this->DB->getFullTableName('loads') . "` "
							 . "WHERE `view_on_home` = '1' AND `available` = '1') ";
					}
					if (in_array('stat', $latest_on_home)) {
						if (!empty($sql)) $sql .= 'UNION ';
						$sql .= "(SELECT `title`, `main`, `date`, `on_home_top`, `id`, `views`, `author_id`, (SELECT \"stat\") AS skey  FROM `" 
							 . $this->DB->getFullTableName('stat') . "` " 
							 . "WHERE `view_on_home` = '1' AND `available` = '1') ";
					}
					if (!empty($sql)) {
						$sql .= 'ORDER BY `on_home_top` DESC, `date` DESC LIMIT ' . Config::read('cnt_latest_on_home');
						$materials = $this->DB->query($sql);	

						//if we have records
						if (count($materials) > 0) {
						
							// Get users(authors)
							$uids = array();
							foreach ($materials as $mat) {
								$uids[] = $mat['author_id'];
							}
							$uids = '(' . implode(', ', $uids) . ')';
							$authors = $this->DB->select('users', DB_ALL, array('cond' => 'WHERE `id` IN ' . $uids));

						
							//if we have materials for view on home page (now we get their an create page)
							$info = null;
							foreach ($materials as $result) {
								foreach ($authors as $author) {
									if ($result['author_id'] == $author['id']) {
										$result['author_status'] = $author['status'];
										break;
									}
								}
							
								$markets = array();
								$result = $this->Parser->quoteTags($result);
								$htmlstats = $this->Parser->getAndParse('tablemat.html');
								
								//moder panel
								$markets['{MODER_PANEL}'] = $this->_getAdminBar($result['id'], $result['skey']);
								$entry_url = get_url(entryUrl($result, $result['skey']));
								$markets['{ENTRY_URL}'] = $entry_url;
								
								
								$announce = $this->Parser->unquoteTags($result['main']);
								$announce = $this->Textarier->getAnnounce($announce, $entry_url, 0, 
									Config::read('announce_lenght'), $result['author_status']);
								$markets['{ANNOUNCE}'] = $this->Parser->quoteTags($announce);
								
								foreach ($result as $key => $value) {
								   $markets['{' . strtoupper($key) . '}'] = h($value);
								}
								
								$info .= $this->_replaceMarkets($markets, $htmlstats);
								
								//set users_id that are on this page
								$this->setCacheTag(array(
									'module_' . $result['skey'],
									'record_id_' . $result['id'],
								));
							}
							
							$html = $info;
							
							$materials_tpl = $this->Parser->getAndParse('materials_container.html');
							$markets = array(
								'{MATERIALS}' => $html,
							);
							$html = $this->_replaceMarkets($markets, $materials_tpl);
							
							
							//write int cache
							if ($this->cached)
								$this->Cache->write($html, $this->cacheKey, $this->cacheTags);
							
						}
					}
				}
				if (empty($html)) $html = __('Materials not found');
				return $this->_view($html);
			}
			return $this->_view(__('Materials not found'));
		}
	}


	
	
	/**
	* @param int $id - record ID
	* @param string $module - module
	* @return string - admin buttons
	*
	* create and return admin bar
	*/
	protected function _getAdminBar($id, $module) {
		$moder_panel = '';
		if ($this->ACL->turn(array($module, 'edit_materials'), false)) {
			$moder_panel .= get_link(get_img('/sys/img/edit_16x16.png', array('alt' => __('Edit'), 'title' => __('Edit'))),
			'/' . $module . '/edit_form/' . $id) . '&nbsp;';
		}
		if ($this->ACL->turn(array($module, 'up_materials'), false)) {
			$moder_panel .= get_link(get_img('/sys/img/up_arrow_16x16.png', array('alt' => __('Up'), 'title' => __('Up'))),
			'/' . $module . '/upper/' . $id, array('onClick' => "return confirm('" . __('Are you sure') . "')")) . '&nbsp;';
		}
		if ($this->ACL->turn(array($module, 'on_home'), false)) {
			$moder_panel .= get_link(get_img('/sys/img/round_ok.png', array('alt' => __('On home'), 'title' => __('On home'))),
			'/' . $module . '/off_home/' . $id, array('onClick' => "return confirm('" . __('Are you sure') . "')")) . '&nbsp;';
		}
		if ($this->ACL->turn(array($module, 'delete_materials'), false)) {
			$moder_panel .= get_link(get_img('/sys/img/delete_16x16.png', array('alt' => __('Delete'), 'title' => __('Delete'))),
			'/' . $module . '/delete/' . $id, array('onClick' => "return confirm('" . __('Are you sure') . "')")) . '&nbsp;';
		}

		return $moder_panel;
	}

	
}
?>