<?php
/*-----------------------------------------------\
| 												 |
|  Author:       Andrey Brykin (Drunya)          |
|  Version:      1.3                             |
|  Project:      CMS                             |
|  package       CMS Fapos                       |
|  subpackege    Search Module                   |
|  copyright     ©Andrey Brykin 2010-2011        |
\-----------------------------------------------*/

/*-----------------------------------------------\
| 												 |
|  any partial or not partial extension          |
|  CMS Fapos,without the consent of the          |
|  author, is illegal                            |
|------------------------------------------------|
|  Любое распространение                         |
|  CMS Fapos или ее частей,                      |
|  без согласия автора, является не законным     |
\-----------------------------------------------*/




class SearchModule extends Module {
	
	
	/**
	* @module_title  title of module
	*/
	public $module_title = 'Поиск';
	/**
	* @module module indentifier
	*/
	public $module = 'search';
	/**
	 * @var int
	 */
	private $minInputStr = 5;
	/**
	 * @var array
	 */
	public $tables = array('posts', 'stat', 'news', 'loads');
	/**
	 * @var boolean
	 */
	private $returnForm = true;
	
	
	
	
	
	
	
	
	
	
	
	/**
	 *
	 *
	 * Doing search and build page with results
	 */
	public function index() {
		//check index
		$this->__checkIndex();

		
		$minInput = Config::read('min_lenght', 'search');
		if (!empty($minInput)) $this->minInputStr = (int)$minInput;
		
		$html = null;
		$error = null;
		if (isset($_POST['search']) || isset($_GET['search'])) {
			$str = (isset($_POST['search'])) ? $_POST['search'] : '';
			if (empty($str)) $str = (isset($_GET['search'])) ? $_GET['search'] : '';
			if (!is_string($str)) $str = (string)$str;
			$str = trim($str);
			
			
			if (empty($str) || mb_strlen($str) < $this->minInputStr) 
				$error = $error . '<li>' . sprintf(__('Wery smaal query'), $this->minInputStr) . '</li>';

           
            if ($this->cached) {
                $this->cacheKey .= '_' . md5($str);
                if ($this->Cache->check($this->cacheKey)) {
                    $html = $this->Cache->read($this->cacheKey);
                    return $this->_view($html);
                }
            }

			
			if (!empty($error)) {
				$_SESSION['errorForm'] = array();
				$_SESSION['errorForm']['search'] = $str;
				$_SESSION['errorForm']['error'] = $error;
				redirect('/search/');
			}
			
			$results = $this->__search($str);
			if (count($results) < 1) {
				$html = __('No results');
			} else {
				foreach ($results as $result) {
					$markets = array();
					$templ = $this->Parser->getAndParse('search_row.html');
					
					if (preg_match('#(.{0,100}' . $str . '.{0,100})#miu', $result['index'], $match)) {
						$announce = $match[1];
					} else {
						$announce = mb_substr($result['index'], 0, 150);
					}
					if (preg_match('#(' . $str . '(([\s]+)|([^\s]{0,100})){0,7})#miu', $announce, $match)) {
						$title = h($match[1]);
					} else {
						$title = h($str);
					}

					
					$announce = str_replace($str, '<strong>' . $str . '</strong>', h($announce));
					$entry_url = get_url('/' . $result['module'] . $result['entity_view'] . $result['entity_id']);
					$markets['{ENTRY_URL}'] = $entry_url;
					$markets['{TITLE}'] = $title;
					$markets['{ANNOUNCE}'] = $announce;
					$html .= $this->_replaceMarkets($markets, $templ);
				}
			}
		}
		
		// Nav block
		$nav = array();
		$nav['{NAVIGATION}'] = get_link(__('Home'), '/') . __('Separator') . $this->module_title;
		$this->_globalize($nav);
		

		$this->page_title = $this->module_title;
		if (!empty($_POST['search'])) $this->page_title .= ' - ' . h($_POST['search']);
		
		$this->returnForm = false;
		$form = $this->form();
		$html = str_replace('{RESULTS}', $html, $form);
		
		//write into cache
		if ($this->cached && !empty($str)) {
			//set users_id that are on this page
			$this->setCacheTag(array(
				'search_str_' . $str,
			));
            $this->cacheKey .= '_' . md5($str);
			$this->Cache->write($html, $this->cacheKey, $this->cacheTags);
		}
			
		return $this->_view($html);
	}
	
	
	

	/**
	 * @return string search form
	 */
	public function form() {
		$html = $this->Parser->getAndParse('search_form.html');
		$action = '/search/';
		$search_str = '';
		$markets = array();
		
		
		//if an errors
		if (isset($_SESSION['errorForm'])) {
			$info = $this->Parser->getAndParse('infomessage.html');
			$info = str_replace( '{INFO_MESSAGE}', $_SESSION['errorForm']['error'], $info );
			$html = $html . $info . "\n";
			$search_str = $_SESSION['errorForm']['search'];
			unset($_SESSION['errorForm']);
		}
		
		$markets['{ACTION}'] = $action;
		$markets['{SEARCH}'] = $search_str;
		if ($this->returnForm)
			$markets['{SEARCH}'] = '';
			
		$html = $this->_replaceMarkets($markets, $html);
		
		return ($this->returnForm) ? $this->_view($html) : $html;
	}

	
	
	/**
	 *
	 */
	private function __checkIndex() {
		$meta_file = R . 'sys/tmp/search/meta.dat';
		if (file_exists($meta_file) && is_readable($meta_file)) {
			$meta = unserialize(file_get_contents($meta_file));
			if (!empty($meta['expire']) && $meta['expire'] > time()) {
				return true;
			} else {
				$this->__createIndex();
			}
		} else {
			touchDir(R . 'sys/tmp/search/');
			$this->__createIndex();
		}
		
		$index_interval = intval(Config::read('index_interval', 'search'));
		if ($index_interval < 1) $index_interval = 1;
		$meta['expire'] = (time() + ($index_interval * 84000));
		file_put_contents($meta_file, serialize($meta));
		return true;
	}
	
	
	
	
	/**
	 * @param string $str
	 * @return array
	 *
	 * Send request and return search results
	 */
	private function __search($str) {
		$words = explode(' ', $str);
		$_words = array();
		foreach ($words as $key => $word) {
			$word = $this->__filterText($word);
			if (mb_strlen($word) < $this->minInputStr) continue;
			$_words[] = $word;
		}
		if (count($_words) < 1) return array();
		$string = resc(implode('* ', $_words) . '*');
		
		//query
		$limit = Config::read('per_page', 'search');
		$results = $this->DB->query("
			SELECT * FROM `" . $this->DB->getFullTableName('search_index') . "`
			WHERE MATCH (`index`) AGAINST ('" . $string . "')
			ORDER BY MATCH (`index`) AGAINST ('" . $string . "') DESC LIMIT " . $limit);
		return $results;
	}
	
	
	/**
	 * 
	 *
	 * Create index for search engine
	 */
	private function __createIndex() {
		if (function_exists('ignore_user_abort')) ignore_user_abort();
		if (function_exists('set_time_limit')) set_time_limit(180);
	
		$this->DB->query("TRUNCATE `" . $this->DB->getFullTableName('search_index') . "`");
		foreach ($this->tables as $table) {
			$records = $this->DB->select($table, DB_ALL);
			if (count($records) > 0) {
				foreach ($records as $rec) {
					foreach ($rec as $field) {
						if (mb_strlen($field) > $this->minInputStr && is_string($field)) {
							//filter text
							$text = $this->__filterText($field);
							if (empty($text) || mb_strlen($text) < $this->minInputStr) continue;
							
							//prepare data to save
							$entity_id = $rec['id'];
							if ($table == 'posts' || $table == 'themes') {
								$entity_view = '/view_theme/';
								$module = 'forum';
								if ($table == 'posts') $entity_id = $rec['id_theme'];
							} else {
								$entity_view = '/view/';
								$module = $table;
							}
							
							//we must update record if an exists
							$data = array(
								'index' => $text,
								'entity_id' => $entity_id,
								'entity_table' => $table,
								'entity_view' => $entity_view,
								'module' => $module,
								'date' => new Expr('NOW()'),
							);
							//save
							$this->DB->save('search_index', $data);
						}
					}
				}
			}
		}
	}
	
	
	/**
	 * @param string $str
	 *
	 * Cut HTML and BB tags. Also another chars
	 */
	private function __filterText($str) {
		$str = preg_replace('#<[^>]*>|\[[^\]]*\]|[,\.=\'"\|\{\}/\\_\+\?\#<>:;\)\(`\-0-9]#iu', '', $str);
		$str = preg_replace('#(^| )[^ ]{1,2}( |$)#iu', ' ', $str);
		$str_to_array = explode(' ', mb_strtolower($str));
		$str_to_array = array_unique($str_to_array);
		$str = implode(' ', $str_to_array);
		return (!empty($str)) ? $str : false;
	}
}
?>