<?php
/*---------------------------------------------\
|											   |
| Author:       Andrey Brykin (Drunya)         |
| Version:      1.3.1                          |
| Project:      CMS                            |
| package       CMS Fapos                      |
| subpackege    Stats Module                   |
| copyright     ©Andrey Brykin 2010-2011       |
|----------------------------------------------|
|											   |
| any partial or not partial extension         |
| CMS Fapos,without the consent of the         |
| author, is illegal                           |
|----------------------------------------------|
| Любое распространение                        |
| CMS Fapos или ее частей,                     |
| без согласия автора, является не законным    |
\---------------------------------------------*/




Class StatModule extends Module {

	/**
	* @module_title  title of module
	*/
	var $module_title = 'Статьи';
	/**
	* @template  layout for module
	*/
	var $template = 'stat';
	/**
	* @module module indentifier
	*/
	var $module = 'stat';


	
	/**
	* default action ( show main page )
	*/
	function index() {
		//turn access
		$this->ACL->turn(array('stat', 'view_list'));
		
		//формируем блок со списком  разделов
		if ($this->cached && $this->Cache->check('category_' . $this->cacheKey)) {
			$this->categories = $this->Cache->read('category_' . $this->cacheKey);
		} else {
			$sql_cat = $this->DB->select('stat_sections', DB_ALL, array('cond' => array('class' => 'section')));
			if (count($sql_cat) > 0) {
				foreach ($sql_cat as $result) {
					$this->categories .= '<li>' . get_link(h($result['title']), '/stat/section/' . $result['id']) . '</li>';
				}
			}
			if (Config::read('cache') == 1)
				$this->Cache->write($this->categories, 'category_' 
				. $this->cacheKey, array('module_stat', 'category_block'));
		}
		
		
		
		//check content cache
		if ($this->cached && $this->Cache->check($this->cacheKey)) {
			$html = $this->Cache->read($this->cacheKey);
		} else {
		
		
			//Узнаем кол-во материалов в БД (!we need to know whether to show hidden )
			if ($this->ACL->turn(array('other', 'can_see_hidden'), false)) {
				$total = $this->DB->select('stat', DB_COUNT);
			} else {
				$total = $this->DB->select('stat', DB_COUNT, array('cond' => array('available' => '1')));
			}
			$cntPages = ceil( $total / Config::read('per_page', 'stat') );
			if ( isset($_GET['page']) ) {
				$page = (int)$_GET['page'];
				if ( $page < 1 ) $page = 1;
			} else {
				$page = 1;
			}
			if ( $page > $cntPages ) $page = $cntPages;
			if ( $cntPages > 1 ) {
				$pages = pagination( $page, $cntPages, '/stat/');
			} else {
				$pages = '&nbsp;';
			}
			
			
			//navigation panel
			$nav = array();
			$nav['{ADD_LINK}'] = ($this->ACL->turn(array('stat', 'add_materials'), false)) ? 
				get_link(__('Add material'), '/stat/add_form/') : '';
			$nav['{NAVIGATION}'] = get_link(__('Home'), '/') 
			. __('Separator') . h($this->module_title);
			$nav['{PAGINATION}'] = $pages;
			$nav['{META}'] = __('Count all material') . $total;
			$this->_globalize($nav);
			
			if ($total == 0) {
				return $this->_view(__('Materials not found'));
			}

			
			$html = '';
			$conditions = array();
			if (!$this->ACL->turn(array('other', 'can_see_hidden'), false)) $conditions['`a`.`available`'] = '1';
			$sql = $this->DB->select('stat', DB_ALL, array(
				'joins' => array(
					array(
						'table' => 'stat_sections',
						'type' => 'LEFT',
						'alias' => 'b',
						'cond' => 'a.`category_id` = b.`id`',
					),
					array(
						'table' => 'stat_sections',
						'type' => 'LEFT',
						'alias' => 'c',
						'cond' => 'b.`section_id` = c.`id`',
					),
					array(
						'table' => 'users',
						'type' => 'LEFT',
						'alias' => 'd',
						'cond' => 'd.`id` = a.`author_id`',
					),
				),
				'fields' => array('a.*', 'b.`title` as category_name', 'b.`section_id` as section_id', 'c.`title` as section_name', 'd.`name` AS author', 'd.`status` AS author_status'),
				'alias' => 'a',
				'cond' => $conditions,
				'order' => 'a.`date` DESC',
				'page' => $page,
				'limit' => Config::read('per_page', 'stat'),
			));
			if (is_object($this->AddFields) && count($sql) > 0) {
				$sql = $this->AddFields->mergeRecords($sql);
			}
			

			foreach ($sql as $result) {
				$markets = array();
				$result = $this->Parser->quoteTags($result);
				$htmlstats = $this->Parser->getAndParse('tablemat.html');
				
				
				$markets['{MODER_PANEL}'] = $this->_getAdminBar($result);
				$entry_url = get_url(entryUrl($result, $this->module));
				$markets['{ENTRY_URL}'] = $entry_url;
	
				$announce = $this->Parser->unquoteTags($result['main']);
				$announce = $this->Textarier->getAnnounce($announce, $entry_url, 0, 
					Config::read('announce_lenght', 'stat'), $result['author_status']);
				$markets['{ANNOUNCE}'] = $this->Parser->quoteTags($announce);
				
				foreach ($result as $key=>$value) {
				   $markets['{'.strtoupper($key).'}'] = h($value);
				}
				
				$markets['{PROFILE_URL}'] = getProfileUrl($result['author_id']);
				$markets['{CATEGORY_URL}'] = get_url('/stat/category/' . $result['category_id']);  
				$html .= $this->_replaceMarkets($markets, $htmlstats);

				
				//set cache tags
				$this->setCacheTag(array(
					'record_id_' . $result['id'],
					'user_id_' . $result['author_id'],
				));
			}

			
			$materials_tpl = $this->Parser->getAndParse('materials_container.html');
			$markets = array(
				'{MATERIALS}' => $html,
			);
			$html = $this->_replaceMarkets($markets, $materials_tpl);
			
			
			//save cache
			if ($this->cached)
			$this->Cache->write($html, $this->cacheKey, $this->cacheTags);
		}
		return $this->_view($html);
	}


	

	 
	function category($id = null) {
		//turn access
		$this->ACL->turn(array('stat', 'view_list'));
		$id = intval($id);
		if (empty($id) || $id < 1) redirect('/');

		
		
		//формируем блок со списком  разделов
		if ($this->cached && $this->Cache->check('category_' . $this->cacheKey)) {
			$this->categories = $this->Cache->read('category_' . $this->cacheKey);
		} else {
			$sql_cat = $this->DB->select('stat_sections', DB_ALL, array(
				'joins' => array(
					array(
						'table' => 'stat_sections',
						'type' => '',
						'alias' => 'b',
						'cond' => '`b`.`section_id` = `a`.`section_id`',
					),
				),
				'alias' => 'a',
				'cond' => array('`a`.`id`' => $id),
			));
			
			if (count($sql_cat) > 0) {
				foreach ($sql_cat as $result) {
					$this->categories .= '<li>' . get_link(h($result['title']), '/stat/category/'.$result['id']) . '</li>';
				}
			}
			if ($this->cached)
				$this->Cache->write($this->categories, 'category_' . $this->cacheKey, array('module_stat', 'category_block'));
		}
		
		
		
		if ($this->cached && $this->Cache->check($this->cacheKey)) {
			$html = $this->Cache->read($this->cacheKey);
		} else {
		
		
			$category = intval($id);
			$conditions = array('category_id' => $category);
			//(!we need to know whether to show hidden )
			if (!$this->ACL->turn(array('other', 'can_see_hidden'), false)) $conditions['available'] = '1';
			
			$total    = $this->DB->select('stat', DB_COUNT, array('cond' => $conditions));
			$cntPages = ceil( $total / Config::read('per_page', 'stat') );
			if ( isset($_GET['page']) ) {
				$page = (int)$_GET['page'];
				if ( $page < 1 ) $page = 1;
			} else {
				$page = 1;
			}
			if ( $page > $cntPages ) $page = $cntPages;
			if ( $cntPages > 1 ) {
				$pages = pagination( $page, $cntPages, '/stat/category/' . $id );
			} else {
				$pages = '&nbsp;';
			}
			
			
			
			//navigation panel
			$category_info = $this->DB->select('stat_sections', DB_ALL, array(
				'joins' => array(
					array(
						'table' => 'stat_sections',
						'alias' => 'b',
						'type' => 'LEFT',
						'cond' => '`b`.`id` = `a`.`section_id`',
					),
				),
				'cond' => array('`a`.`id`' => $id),
				'alias' => 'a',
				'fields' => array('a.`title` as ctitle', 'a.`id` as cid', 'b.`title` as stitle', 'b.`id` as sid'),
			));
			
			$nav = array();
			$nav['{NAVIGATION}'] = get_link(__('Home'), '/') . __('Separator') 
				. get_link(h($this->module_title)
				, '/stat/') . __('Separator') . get_link(h($category_info[0]['stitle']), '/stat/section/' 
				. $category_info[0]['sid']) . __('Separator') . h($category_info[0]['ctitle']);
			$nav['{ADD_LINK}'] = ($this->ACL->turn(array('stat', 'add_materials'), false)) ? 
				get_link(__('Add material'), '/stat/add_form/') : '';
			$nav['{PAGINATION}'] = $pages;
			$nav['{META}'] = __('Count material in cat') . $total;
			$this->_globalize($nav);
			
			
			if ($total == 0) {
				return $this->_view(__('Materials not found'));
			}
			
			
			$html = '';
			$conditions = array('`a`.`category_id`' => $id);
			if (!$this->ACL->turn(array('other', 'can_see_hidden'), false)) $conditions['`a`.`available`'] = '1';
			$sql = $this->DB->select('stat', DB_ALL, array(
				'joins' => array(
					array(
						'table' => 'stat_sections',
						'type' => 'LEFT',
						'alias' => 'b',
						'cond' => 'a.`category_id` = b.`id`',
					),
					array(
						'table' => 'stat_sections',
						'type' => 'LEFT',
						'alias' => 'c',
						'cond' => 'b.`section_id` = c.`id`',
					),
					array(
						'table' => 'users',
						'type' => 'LEFT',
						'alias' => 'd',
						'cond' => 'd.`id` = a.`author_id`',
					),
				),
				'fields' => array('`a`.*', '`b`.`title` as category_name', '`b`.`section_id` as section_id',
				'`c`.`title` as section_name', '`d`.`name` AS author', '`d`.`status` AS author_status'),
				'alias' => 'a',
				'cond' => $conditions,
				'order' => '`a`.`date` DESC',
				'page' => $page,
				'limit' => Config::read('per_page', 'stat'),
			));
			if (is_object($this->AddFields) && count($sql) > 0) {
				$sql = $this->AddFields->mergeRecords($sql);
			}
			

			foreach ($sql as $result) {
				$markets = array();
				$result = $this->Parser->quoteTags($result);
				$htmlstats = $this->Parser->getAndParse('tablemat.html');

				
				$markets['{MODER_PANEL}'] = $this->_getAdminBar($result);
				$entry_url = get_url(entryUrl($result, $this->module));
				$markets['{ENTRY_URL}'] = $entry_url;
				
				$announce = $this->Parser->unquoteTags($result['main']);
				$announce = $this->Textarier->getAnnounce($announce, $entry_url, 0, 
					Config::read('announce_lenght', 'stat'), $result['author_status']);
				$markets['{ANNOUNCE}'] = $this->Parser->quoteTags($announce);
				
				foreach ($result as $key => $value) {
				   $markets['{'.strtoupper($key).'}'] = h($value);
				}
				
				$markets['{PROFILE_URL}'] = getProfileUrl($result['author_id']);
				$markets['{CATEGORY_URL}'] = get_url('/stat/category/' . $result['category_id']);  
				$html .= $this->_replaceMarkets($markets, $htmlstats);
				
				//set cache tags
				$this->setCacheTag(array(
					'record_id_' . $result['id'],
					'user_id_' . $result['author_id'],
					'category_id_' . $id,
				));
			}
			
			
			$materials_tpl = $this->Parser->getAndParse('materials_container.html');
			$markets = array(
				'{MATERIALS}' => $html,
			);
			$html = $this->_replaceMarkets($markets, $materials_tpl);
			
			
			//write cache
			if ($this->cached)
				$this->Cache->write($html, $this->cacheKey, $this->cacheTags);
		}
		return $this->_view($html);
	}
	  
	  
	  
 
	  
	  
	function section($id = null) {
		//turn access
		$this->ACL->turn(array('stat', 'view_list'));
		$id = intval($id);
		if (empty($id) || $id < 1) redirect('/');

		
		
		//формируем блок со списком  разделов
		if ($this->cached && $this->Cache->check('category_' . $this->cacheKey)) {
			$this->categories = $this->Cache->read('category_' . $this->cacheKey);
		} else {
			$sql_cat = $this->DB->select('stat_sections', DB_ALL, array(
				'cond' => array(
					'class' => 'category', 
					'section_id' => $id
				)
			));
			if (count($sql_cat) > 0) {
				foreach ($sql_cat as $result) {
					$this->categories .= '<li>' . get_link(h($result['title']), '/stat/category/'.$result['id']) . '</li>';
				}
			}
			if ($this->cached)
				$this->Cache->write($this->categories, 'category_' 
				. $this->cacheKey, array('module_stat', 'category_block'));
		}

		
		
		if ($this->cached && $this->Cache->check($this->cacheKey)) {
			$html = $this->Cache->read($this->cacheKey);
		} else {
		
		
			$conditions = array('section_id' => $id);
			//(!we need to know whether to show hidden )
			if (!$this->ACL->turn(array('other', 'can_see_hidden'), false)) $conditions['available'] = '1';
			$total = $this->DB->select('stat', DB_COUNT, array('cond' => $conditions));
			
			
			$cntPages = ceil( $total / Config::read('per_page', 'stat') );
			if ( isset($_GET['page']) ) {
				$page = (int)$_GET['page'];
				if ( $page < 1 ) $page = 1;
			} else {
				$page = 1;
			}
			if ( $page > $cntPages ) $page = $cntPages;
			if ( $cntPages > 1 ) {
				$pages = pagination( $page, $cntPages, '/stat/section/' . $id . '');
			} else {
				$pages = '&nbsp;';
			}
			
			//navigation panel
			$section_info = $this->DB->select('stat_sections', DB_FIRST, array(
				'cond' => array(
					'id' => $id,
					'class' => 'section',
				),
			));
			
			$nav = array();
			$nav['{NAVIGATION}'] = get_link(__('Home'), '/') . __('Separator') 
				. get_link(h($this->module_title)
				, '/stat/') . __('Separator') . h($section_info[0]['title']);
			$nav['{ADD_LINK}'] = ($this->ACL->turn(array('stat', 'add_materials'), false)) ? 
				get_link(__('Add material'), '/stat/add_form/') : '';
			$nav['{PAGINATION}'] = $pages;
			$nav['{META}'] = __('Count material in cat') . $total;
			$this->_globalize($nav);
			
			
			if($total == 0) {
				$html = __('Materials not found');
				return $this->_view($html);
			}
			
			
			$html = '';
			$conditions = array('`b`.`section_id`' => $id);
			if (!$this->ACL->turn(array('other', 'can_see_hidden'), false)) $conditions['`a`.`available`'] = '1';
			$sql = $this->DB->select('stat', DB_ALL, array(
				'joins' => array(
					array(
						'table' => 'stat_sections',
						'type' => 'LEFT',
						'alias' => 'b',
						'cond' => 'a.`category_id` = b.`id`',
					),
					array(
						'table' => 'stat_sections',
						'type' => 'LEFT',
						'alias' => 'c',
						'cond' => 'b.`section_id` = c.`id`',
					),
					array(
						'table' => 'users',
						'type' => 'LEFT',
						'alias' => 'd',
						'cond' => 'd.`id` = a.`author_id`',
					),
				),
				'fields' => array('`a`.*', '`b`.`title` as category_name', '`b`.`section_id` as section_id',
				'`c`.`title` as section_name', '`d`.`name` AS author', '`d`.`status` AS author_status'),
				'alias' => 'a',
				'cond' => $conditions,
				'order' => '`a`.`date` DESC',
				'page' => $page,
				'limit' => Config::read('per_page', 'stat'),
			));
			if (is_object($this->AddFields) && count($sql) > 0) {
				$sql = $this->AddFields->mergeRecords($sql);
			}
			
			
			foreach ($sql as $result) {
				$markets = array();
				$result = $this->Parser->quoteTags($result);
				$htmlstats = $this->Parser->getAndParse('tablemat.html');

				
				
				$markets['{MODER_PANEL}'] = $this->_getAdminBar($result);
				$entry_url = get_url(entryUrl($result, $this->module));
				$markets['{ENTRY_URL}'] = $entry_url;
				
				$announce = $this->Parser->unquoteTags($result['main']);
				$announce = $this->Textarier->getAnnounce($announce, $entry_url, 0, 
					Config::read('announce_lenght', 'stat'), $result['author_status']);
				$markets['{ANNOUNCE}'] = $this->Parser->quoteTags($announce);
				
				foreach ($result as $key=>$value) {
				   $markets['{'.strtoupper($key).'}'] = h($value);
				}
				
				$markets['{PROFILE_URL}'] = getProfileUrl($result['author_id']);
				$markets['{CATEGORY_URL}'] = get_url('/stat/category/' . $result['category_id']);   
				$html .= $this->_replaceMarkets($markets, $htmlstats); 

				//set cache tags
				$this->setCacheTag(array(
					'record_id_' . $result['id'],
					'user_id_' . $result['author_id'],
					'section_id_' . $id,
				));
			}
			
			
			$materials_tpl = $this->Parser->getAndParse('materials_container.html');
			$markets = array(
				'{MATERIALS}' => $html,
			);
			$html = $this->_replaceMarkets($markets, $materials_tpl);
				

			//write cache
			if ($this->cached)
				$this->Cache->write($html, $this->cacheKey, $this->cacheTags);
		}
		return $this->_view($html);
	}
	  
	  

	  


	function view ($id = null) {
		$this->ACL->turn(array('stat', 'view_materials'));
		$id = intval($id);
		if (empty($id) || $id < 1) redirect('/');

		
		
		//  в другом случае извлекаем шаблон отображения материала
		$html = $this->Parser->getAndParse('vievmat.html');
		
		
		// извлекаем из БД информацию материала
		$sql = $this->DB->select('stat', DB_FIRST, array(
			'joins' => array(
				array(
					'table' => 'stat_sections',
					'type' => 'LEFT',
					'alias' => 'b',
					'cond' => 'a.`category_id` = b.`id`',
				),
				array(
					'table' => 'stat_sections',
					'type' => 'LEFT',
					'alias' => 'c',
					'cond' => 'b.`section_id` = c.`id`',
				),
				array(
					'table' => 'users',
					'type' => 'LEFT',
					'alias' => 'd',
					'cond' => 'd.`id` = a.`author_id`',
				),
			),
			'fields' => array('`a`.*', '`b`.`title` as category_name', '`b`.`section_id` as section_id',
			'`c`.`title` as section_name', '`d`.`name` AS author', '`d`.`status` AS author_status'),
			'alias' => 'a',
			'cond' => array('`a`.`id`' => $id),
		));
		if (count($sql) < 1) return showInfoMessage(__('Some error occurred'), '/stat/');
		if ($sql[0]['available'] == 0 && !$this->ACL->turn(array('other', 'can_see_hidden'), false)) 
			return showInfoMessage(__('Permission denied'), '/stat/' );
			
			
		if (is_object($this->AddFields) && count($sql) > 0) {
			$sql = $this->AddFields->mergeRecords($sql);
		}
		
		$result = $this->Parser->quoteTags($sql[0]);


		// Navigation Panel
		$nav = array();
		$nav['{MODULE_URL}'] = get_url('/stat/');
		$nav['{SECTION_URL}'] = get_url('/stat/section/' . $result['section_id']);
		$nav['{SECTION_NAME}'] = h($result['section_name']);
		$nav['{CATEGORY_URL}'] = get_url('/stat/category/' . $result['category_id']);
		$nav['{CATEGORY_NAME}'] = h($result['category_name']);
		$this->_globalize($nav);

		
		
		// Local markets
		$markets = array();
		$markets['{MODER_PANEL}'] = $this->_getAdminBar($result);

		$text_stat  = $this->Parser->unquoteTags($result['main']);
		$text_stat  = $this->Textarier->print_page($text_stat, $result['author_status']);
		$markets['{MAIN_TEXT}']  = $this->Parser->quoteTags($text_stat);
		
		foreach ($result as $key => $value) {
			$markets['{'.strtoupper($key).'}'] = h($value);
		}
		
		$markets['{PROFILE_URL}'] = getProfileUrl($result['author_id']);
		$markets['{CATEGORY_URL}'] = get_url('/stat/category/' . $result['category_id']);
		$html = $this->_replaceMarkets($markets, $html);

		$this->DB->save('stat', array(
			'`views` = `views` + 1',
			'id' => $id,
		));
		
		$this->page_title = $this->page_title . '-' . h($result['title']);
		if (!empty($result['tags'])) $this->page_meta_keywords = h($result['tags']);
		if (!empty($result['description'])) $this->page_meta_description = h($result['description']);
		
		
		/* COMMENT BLOCK */
		if (Config::read('comment_active', 'stat') == 1 
		&& $this->ACL->turn(array('stat', 'view_comments'), false) && $result['commented'] == 1) {
			if ($this->ACL->turn(array('stat', 'add_comments'), false)) 
				$this->comments  = $this->_add_comment_form($id);
			$this->comments  = $this->_get_comments($id) . $this->comments;
		}
		
		
		//формируем блок со списком  разделов
		if ($this->cached && $this->Cache->check('category_' . $this->cacheKey)) {
			$this->categories = $this->Cache->read('category_' . $this->cacheKey);
		} else {
			$cats = $this->DB->select('stat_sections', DB_ALL, array(
				'cond' => array(
					'section_id' => $result['section_id']
				)
			));
			if (count($cats) > 0) {
				foreach ($cats as $result) {
					$this->categories .= '<li>' . get_link(h($result['title']), '/stat/category/' . $result['id']) . '</li>';
				}
			}
			if ($this->cached)
				$this->Cache->write($this->categories, 'category_' 
				. $this->cacheKey, array('module_stat', 'category_block'));
		}
		
		
		$this->DB->cleanSqlCache();
		return $this->_view($html);
	}





	 
	function add_form () {
		//turn access
		$this->ACL->turn(array('stat', 'add_materials'));
		$writer_status = (!empty($_SESSION['user']['status'])) ? $_SESSION['user']['status'] : 0;

		
		//формируем блок со списком  разделов
		if ($this->cached && $this->Cache->check('category_' . $this->cacheKey)) {
			$this->categories = $this->Cache->read('category_' . $this->cacheKey);
		} else {
			//формируем блок со списком  разделов
			$sql_cat = $this->DB->select('stat_sections', DB_ALL, array(
				'cond' => array(
					'class' => 'section'
				)
			));
			if (count($sql_cat) > 0) {
				foreach ($sql_cat as $result) {
					$this->categories .= '<li>' . get_link(h($result['title'])
					, '/stat/section/' . $result['id']) . '</li>';
				}
			}
			if ($this->cached)
				$this->Cache->write($this->categories, 'category_' 
				. $this->cacheKey, array('module_stat', 'category_block'));
		}
		
		
		$title 			= null;
		$add 			= null;
		$description 	= null;
		$tags 			= null;
		$sourse			= null;
		$sourse_email	= null;
		$sourse_site	= null;
		$commented	    = null;
		$available	    = null;
		$html = $this->Parser->getAndParse('addform.html' );
		
		// Additional fields
		if (is_object($this->AddFields)) {
			$_addFields = $this->AddFields->getInputs();
			foreach($_addFields as $k => $field) {
				$html = str_replace('{' . strtoupper($k) . '}', $field, $html );
			}
		}
		
		
		
		$sql = $this->DB->select('stat_sections', DB_ALL, array('cond' => array('class' => 'section')));
		$cats_change = '';
		foreach ($sql as $fetch) {
			$cats_change .= "<option disabled='disabled'>" . h($fetch['title']) . "</option>";
			$categories   = $this->DB->select('stat_sections', DB_ALL, array(
				'cond' => array(
					'section_id' => $fetch['id']
				)
			));
			
			foreach ($categories as $fetch_cat) {
			
				if (!empty($_SESSION['FpsForm']['in_cat']) && $_SESSION['FpsForm']['in_cat'] == $fetch_cat['id'])
					$selected = ' selected="selected"';
				else if (!empty($_SESSION['viewMessage']['in_cat']) && $_SESSION['viewMessage']['in_cat'] == $fetch_cat['id'])
					$selected = ' selected="selected"';
				else
					$selected = '';
					
				$cats_change .= '<option value="' . $fetch_cat['id'] . '"'
				. $selected . ' >' . h($fetch_cat['title']) . '</option>';
			}
		}

		
		
		// Preview
		if (isset($_SESSION['viewMessage']) and !empty($_SESSION['viewMessage']['mainText'])) {
			$view = $this->Parser->getAndParse('previewmessage.html');
			$view = str_replace('{MESSAGE}', 
				$this->Textarier->print_page($_SESSION['viewMessage']['mainText'], $writer_status), $view);
			$html     			= $html.$view."\n";
			$title    		    = h($_SESSION['viewMessage']['title']);
			$add       			= h($_SESSION['viewMessage']['mainText']);
			$description		= h($_SESSION['viewMessage']['description']);
			$tags 				= h($_SESSION['viewMessage']['tags']);
			$sourse 			= h($_SESSION['viewMessage']['sourse']);
			$sourse_email 		= h($_SESSION['viewMessage']['sourse_email']);
			$sourse_site 		= h($_SESSION['viewMessage']['sourse_site']);
			$commented 			= h($_SESSION['viewMessage']['commented']);
			$available 			= h($_SESSION['viewMessage']['available']);
			unset($_SESSION['viewMessage']);
		}

		// Errors
		if (isset($_SESSION['FpsForm'])) {
			$info = $this->Parser->getAndParse('infomessage.html' );
			$info = str_replace( '{INFO_MESSAGE}', $_SESSION['FpsForm']['error'], $info );
			$html     		= $info . $html . "\n";
			$title     		= h($_SESSION['FpsForm']['title']);
			$add  	   		= h($_SESSION['FpsForm']['mainText']);
			$description 	= h($_SESSION['FpsForm']['description']);
			$tags 			= h($_SESSION['FpsForm']['tags']);
			$sourse			= h($_SESSION['FpsForm']['sourse']);
			$sourse_email	= h($_SESSION['FpsForm']['sourse_email']);
			$sourse_site	= h($_SESSION['FpsForm']['sourse_site']);
			$commented	    = h($_SESSION['FpsForm']['commented']);
			$available	    = h($_SESSION['FpsForm']['available']);
			unset($_SESSION['FpsForm']);
		}
		
		//comments and hide
		$commented = (!empty($commented) || !isset($_POST['submitForm'])) ? 'checked="checked"' : '';
		if (!$this->ACL->turn(array('stat', 'record_comments_management'), false)) $commented .= ' disabled="disabled"';
		$available = (!empty($available) || !isset($_POST['submitForm'])) ? 'checked="checked"' : '';
		if (!$this->ACL->turn(array('stat', 'hide_material'), false)) $available .= ' disabled="disabled"';

		
		$markets = array();
		$markets['{ACTION}'] = '/stat/add/';
		$markets['{CATS_SELECTOR}'] = $cats_change;
		$markets['{TITLE}'] = $title;
		$markets['{MAIN_TEXT}'] = $add;
		$markets['{DESCRIPTION}'] = $description;
		$markets['{TAGS}'] = $tags;
		$markets['{SOURSE}'] = $sourse;
		$markets['{SOURSE_EMAIL}'] = $sourse_email;
		$markets['{SOURSE_SITE}'] = $sourse_site;
		$markets['{COMMENTED}'] = $commented;
		$markets['{AVAILABLE}'] = $available;
		$html = $this->_replaceMarkets($markets, $html);
		
		
		//navigation panel
		$nav = array();
		$nav['{NAVIGATION}'] = get_link(__('Home'), '/') 
			. __('Separator') . get_link(h($this->module_title)
			, '/stat/') . __('Separator') . __('Добавление материала');
		$this->_globalize($nav);
		
		
		
		return $this->_view($html);
	}





	// Функция добавляет новую новость 
	function add() {
		//turn access
		$this->ACL->turn(array('stat', 'view_list'));
		if (!isset($_POST['title']) 
		|| !isset($_POST['mainText']) 
		|| !isset($_POST['cats_selector'])) {
			redirect('/');
		}
		if ( !is_numeric($_POST['cats_selector']) ) {
			redirect('/');
		}
		$error  = '';
		// Additional fields checker
		if (is_object($this->AddFields)) {
			$_addFields = $this->AddFields->checkFields();
			if (is_string($_addFields)) $error .= $_addFields; 
		}
		
		$fields = array('description', 'tags', 'sourse', 'sourse_email', 'sourse_site');
		$fields_settings = Config::read('fields', 'stat');
		foreach ($fields as $field) {
			if (empty($_POST[$field]) && in_array($field, $fields_settings)) {
				$error = $error.'<li>' . __('Empty field') . '"' . $field . '"</li>'."\n";
				$$field = null;
			} else {
				$$field = trim($_POST[$field]);
			}
		}
		// Обрезаем переменные до длины, указанной в параметре maxlength тега input
		$title   	= trim(mb_substr( $_POST['title'], 0, 128 ));
		$add 		= trim($_POST['mainText']);
		$in_cat 	= intval($_POST['cats_selector']);
		$commented = (!empty($_POST['commented'])) ? 1 : 0;
		$available = (!empty($_POST['available'])) ? 1 : 0;
		
		
		// Если пользователь хочет посмотреть на сообщение перед отправкой
		if ( isset( $_POST['viewMessage'] ) ) {
			$_SESSION['viewMessage'] = array_merge(array('title' => null, 'mainText' => null, 'in_cat' => $in_cat,
				'description' => null, 'tags' => null, 'sourse' => null, 'sourse_email' => null, 
				'sourse_site' => null, 'commented' => null, 'available' => null), $_POST);
			redirect('/stat/add_form/');
		}

		// Check fields
		$valobj = new Validate;
		if ( empty( $in_cat ) )                     
			$error = $error.'<li>' . __('Category not selected') . '</li>'."\n";
		if ( empty( $title ) )                       
			$error = $error.'<li>' . __('Empty field "title"') . '</li>'."\n";
		elseif (!$valobj->cha_val($title, V_TITLE))  
			$error = $error.'<li>' . __('Wrong chars in "title"') . '</li>'."\n";
		if ( empty( $add ) )                    	 
			$error = $error.'<li>' . __('Empty field "material"') . '</li>'."\n";
		else if (mb_strlen($add) > Config::read('max_lenght', 'stat'))
			$error = $error.'<li>' . sprintf(__('Wery big "material"'), Config::read('max_lenght', 'stat')) . '</li>'."\n";
		if (!empty($tags) && !$valobj->cha_val($tags, V_TITLE)) 
			$error = $error.'<li>' . __('Wrong chars in "tags"') . '</li>'."\n";
		if (!empty($sourse) && !$valobj->cha_val($sourse, V_TITLE)) 
			$error = $error.'<li>' . __('Wrong chars in "sourse"') . '</li>'."\n";
		if (!empty($sourse_email) && !$valobj->cha_val($sourse_email, V_MAIL)) 
			$error = $error.'<li>' . __('Wrong chars in "email"') . '</li>'."\n";
		if (!empty($sourse_site) && !$valobj->cha_val($sourse_site, V_URL)) 
			$error = $error.'<li>' . __('Wrong chars in "sourse site"') . '</li>'."\n";
		
		
		// Errors
		if ( !empty( $error ) ) {
			$_SESSION['FpsForm'] = array_merge(array('title' => null, 'mainText' => null, 'in_cat' => $in_cat,
				'description' => null, 'tags' => null, 'sourse' => null, 'sourse_email' => null, 
				'sourse_site' => null, 'commented' => null, 'available' => null), $_POST);
			$_SESSION['FpsForm']['error']   = '<p class="errorMsg">' . __('Some error in form') . '</p>'.
				"\n".'<ul class="errorMsg">'."\n".$error.'</ul>'."\n";
			redirect('/stat/add_form/');
		}

		$sql = $this->DB->select('stat_sections', DB_FIRST, array('cond' => array('id' => $in_cat)));
		$info_cat = $sql[0];
		if (!$this->ACL->turn(array('stat', 'record_comments_management'), false)) $commented = '1';
		if (!$this->ACL->turn(array('stat', 'hide_material'), false)) $available = '1';
		
		
		// Защита от того, чтобы один пользователь не добавил
		// 100 материалов за одну минуту
		if ( isset( $_SESSION['unix_last_post'] ) and ( time()-$_SESSION['unix_last_post'] < 10 ) ) {
			return showInfoMessage(__('Your message has been added'), '/stat/');
		}
		
		// Формируем SQL-запрос на добавление темы	
		$add = mb_substr($add, 0, Config::read('max_lenght', 'stat'));
		$res = $this->DB->save('stat', array(
			'title'        => $title,
			'main'         => $add,
			'date'         => new Expr('NOW()'),
			'author_id'    => $_SESSION['user']['id'],
			'category_id'  => $info_cat['id'],
			'section_id'   => $info_cat['section_id'],
			'description'  => $description,
			'tags'         => $tags,
			'sourse'  	   => $sourse,
			'sourse_email' => $sourse_email,
			'sourse_site'  => $sourse_site,
			'commented'    => $commented,
			'available'    => $available,
			'view_on_home' => $info_cat['view_on_home'],
		));
		$last_id = mysql_insert_id();
		if (is_object($this->AddFields)) {
			$this->AddFields->save($last_id, $_addFields);
		}
		
		//clean cache
		$this->Cache->clean(CACHE_MATCHING_TAG, array('module_stat'));
		$this->DB->cleanSqlCache();
		if ($this->Log) $this->Log->write('adding stat', 'stat id(' . $last_id . ')');
		return showInfoMessage(__('Material successful added'), '/stat/' );
							  
	}





	// Функция возвращает форму для редактирования новости;
	// ID новости передаются методом GET
	function edit_form($id = null) {	
		$id = (int)$id;
		if ( $id < 1 ) redirect('/');
		$writer_status = (!empty($_SESSION['user']['status'])) ? $_SESSION['user']['status'] : 0;

		
		//формируем блок со списком  разделов
		if ($this->cached && $this->Cache->check('category_' . $this->cacheKey)) {
			$this->categories = $this->Cache->read('category_' . $this->cacheKey);
		} else {
			//формируем блок со списком  разделов
			$sql_cat = $this->DB->select('stat_sections', DB_ALL, array(
				'cond' => array(
					'class' => 'section'
				)
			));
			if (count($sql_cat) > 0) {
				foreach ($sql_cat as $result) {
					$this->categories .= '<li>' . get_link(h($result['title']), '/stat/section/' . $result['id']) . '</li>';
				}
			}
			if ($this->cached)
				$this->Cache->write($this->categories, 'category_' 
				. $this->cacheKey, array('module_stat', 'category_block'));
		}
		
		
		
		$res = $this->DB->select('stat', DB_FIRST, array(
			'joins' => array(
				array(
					'table' => 'stat_sections',
					'type' => 'LEFT',
					'alias' => 'b',
					'cond' => 'a.`category_id` = b.`id`',
				),
				array(
					'table' => 'stat_sections',
					'type' => 'LEFT',
					'alias' => 'c',
					'cond' => 'b.`section_id` = c.`id`',
				),
				array(
					'table' => 'users',
					'type' => 'LEFT',
					'alias' => 'd',
					'cond' => 'd.`id` = a.`author_id`',
				),
			),
			'fields' => array('`a`.*', '`b`.`title` as category_name', '`b`.`section_id` as section_id',
			'`c`.`title` as section_name', '`d`.`name` AS author'),
			'alias' => 'a',
			'cond' => array('`a`.`id`' => $id),
		));
		if (count($res) == 0) redirect('/stat/');
		
		if ($res[0]['available'] == 0 && !$this->ACL->turn(array('other', 'can_see_hidden'), false))
			return showInfoMessage(__('Permission denied'), '/stat/' );
			
		// Additional fields
		if (is_object($this->AddFields) && count($res) > 0) {
			$res = $this->AddFields->mergeRecords($res, true);
		}
		
		
		$stat = $res[0];
		$html = '';
		$markets = array();
		
		if (!$this->ACL->turn(array('stat', 'edit_materials')) 
		|| (!empty($_SESSION['user']['id']) && $stat['author_id'] == $_SESSION['user']['id'] 
		&& !$this->ACL->turn(array('stat', 'edit_mine_materials')))) {
			return showInfoMessage(__('Permission denied'), '/stat/' );
		}

		
		//предварительный просмотр
		if (isset($_SESSION['viewMessage']) and !empty($_SESSION['viewMessage']['mainText'])) {
			$view = $this->Parser->getAndParse('previewmessage.html');
			$view = str_replace('{MESSAGE}', 
				$this->Textarier->print_page($_SESSION['viewMessage']['mainText'], $writer_status), $view);
			$html               = $html . $view . "\n";
			$title    		    = h($_SESSION['viewMessage']['title']);
			$edit       		= h($_SESSION['viewMessage']['mainText']);
			$description		= h($_SESSION['viewMessage']['description']);
			$tags 				= h($_SESSION['viewMessage']['tags']);
			$sourse 			= h($_SESSION['viewMessage']['sourse']);
			$sourse_email 		= h($_SESSION['viewMessage']['sourse_email']);
			$sourse_site 		= h($_SESSION['viewMessage']['sourse_site']);
			$commented 			= h($_SESSION['viewMessage']['commented']);
			$available 			= h($_SESSION['viewMessage']['available']);
			unset($_SESSION['viewMessage']);
		} else {
			// Errors
			if ( isset( $_SESSION['FpsForm'] ) ) {
				$html     			= $html . $_SESSION['FpsForm']['error'];
				$title    			= h($_SESSION['FpsForm']['title']);
				$edit               = h($_SESSION['FpsForm']['mainText']);
				$description		= h($_SESSION['FpsForm']['description']);
				$tags 				= h($_SESSION['FpsForm']['tags']);
				$sourse 			= h($_SESSION['FpsForm']['sourse']);
				$sourse_email 		= h($_SESSION['FpsForm']['sourse_email']);
				$sourse_site 		= h($_SESSION['FpsForm']['sourse_site']);
				$commented 			= h($_SESSION['FpsForm']['commented']);
				$available 			= h($_SESSION['FpsForm']['available']);
				unset( $_SESSION['FpsForm'] );
			} else {
				$title    			= h($stat['title']);
				$edit     			= h($stat['main']);
				$description		= h($stat['description']);
				$tags 				= h($stat['tags']);
				$sourse 			= h($stat['sourse']);
				$sourse_email 		= h($stat['sourse_email']);
				$sourse_site 		= h($stat['sourse_site']);
				$commented 			= h($stat['commented']);
				$available 			= h($stat['available']);
			}
		}
		
		//comments and hide
		$commented = (!empty($commented)) ? 'checked="checked"' : '';
		if (!$this->ACL->turn(array('stat', 'record_comments_management'), false)) 
			$commented .= ' disabled="disabled"';
		$available = (!empty($available)) ? 'checked="checked"' : '';
		if (!$this->ACL->turn(array('stat', 'hide_material'), false))
			$available .= ' disabled="disabled"';
		
		
		$sql = $this->DB->select('stat_sections', DB_ALL, array('cond' => array('class' => 'section')));
		$cats_change = '';
		foreach ($sql as $fetch) {
			$cats_change .= "<option disabled='disabled'>".$fetch['title']."</option>";
			$categories   = $this->DB->select('stat_sections', DB_ALL, array(
					'cond' => array(
						'section_id' => $fetch['id']
					)
			));
			foreach ($categories as $fetch_cat) {
				if($stat['category_name'] == $fetch_cat['title']) {
					$cats_change .= "<option value=\"" . $fetch_cat['id'] 
					. "\" selected=\"selected\">" . h($fetch_cat['title']) . "</option>";
				} else {
					$cats_change .= "<option value=\"" . $fetch_cat['id'] . "\">"
					. h($fetch_cat['title']) . "</option>";
				}
			}
		}
		
		$tpl = $this->Parser->getAndParse('editform.html' );
		
		$markets['{ACTION}'] = get_url('/stat/update/' . $id);
		$markets['{CATS_SELECTOR}'] = $cats_change;
		$markets['{AUTHOR}'] = h($stat['author']);
		$markets['{MAIN_TEXT}'] = $edit;
		$markets['{TITLE}'] = $title;
		$markets['{DESCRIPTION}'] = $description;
		$markets['{TAGS}'] = $tags;
		$markets['{SOURSE}'] = $sourse;
		$markets['{SOURSE_EMAIL}'] = $sourse_email;
		$markets['{SOURSE_SITE}'] = $sourse_site;
		$markets['{COMMENTED}'] = $commented;
		$markets['{AVAILABLE}'] = $available;
		foreach ($stat as $key => $value) {
			if (preg_match('#^add_field_[\d]+$#i', $key) && is_object($this->AddFields)) {
				$markets['{' . strtoupper($key) . '}'] = h($value);
			}
		}
		
		$markets = $this->Parser->quoteTags($markets);
		$html = $html . $this->_replaceMarkets($markets, $tpl);

		
		//navigation panel
		$nav = array();
		$nav['{NAVIGATION}'] = get_link(__('Home'), '/') . __('Separator') . get_link(h($this->module_title)
			, '/stat/') . __('Separator') . __('Material editing');
		$this->_globalize($nav);
		
		
		return $this->_view($html);
	}





	// Функция обновляет информацию о новости 
	// уникальный ID новости передается методом GET
	function update($id = null) {		
		// Если не переданы данные формы - функция вызвана по ошибке
		if (empty( $id ) 
		|| !isset( $_POST['title'] ) 
		||  !isset( $_POST['mainText'] ) 
		|| !isset($_POST['cats_selector'])) {
			redirect('/');
		}
		$id = (int)$id;
		if ( $id < 1 ) {
			redirect('/');
		}

		// Получаем из БД информацию о редактируемой теме
		$res = $this->DB->select('stat', DB_FIRST, array('cond' => array('id' => $id)));
		if (count($res) == 0 ) redirect('/stat/');
		$stat = $res[0];
		$html = '';
		
		if (!$this->ACL->turn(array('stat', 'edit_materials')) 
		|| (!empty($_SESSION['user']['id']) && $stat['author_id'] == $_SESSION['user']['id'] 
		&& !$this->ACL->turn(array('stat', 'edit_mine_materials')))) {
			return showInfoMessage(__('Permission denied'), '/stat/' );
		}
		$error  = null;
		if (is_object($this->AddFields)) {
			$_addFields = $this->AddFields->checkFields();
			if (is_string($_addFields)) $error .= $_addFields; 
		}
		
		$valobj = new Validate;
		$fields = array('description', 'tags', 'sourse', 'sourse_email', 'sourse_site');
		$fields_settings = Config::read('fields', 'stat');
		foreach ($fields as $field) {
			if (empty($_POST[$field]) && in_array($field, $fields_settings)) {
				$error = $error.'<li>' . __('Empty field') . '"' . $field . '"</li>'."\n";
				$$field = null;
			} else {
				$$field = trim($_POST[$field]);
			}
		}
		// Обрезаем переменные до длины, указанной в параметре maxlength тега input
		$title     = trim(mb_substr( $_POST['title'], 0, 128 ));
		$edit      = trim($_POST['mainText']);
		$commented = (!empty($_POST['commented'])) ? 1 : 0;
		$available = (!empty($_POST['available'])) ? 1 : 0;
		
		
		// Если пользователь хочет посмотреть на сообщение перед отправкой
		if (isset($_POST['viewMessage'])) {
			$_SESSION['viewMessage'] = array_merge(array('title' => null, 'mainText' => null, 
				'description' => null, 'tags' => null, 'sourse' => null, 'sourse_email' => null, 
				'sourse_site' => null, 'commented' => null, 'available' => null), $_POST);
			redirect('/stat/edit_form/' . $id );
		}
		
		// Check fields
		if ( empty( $title ) )                    
			$error = $error.'<li>' . __('Empty field "title"') . '</li>'."\n";
		if (!Validate::cha_val($title, V_TITLE))  
			$error = $error.'<li>' . __('Wrong chars in "title"') . '</li>'."\n";
		if ( empty( $edit ) )                     
			$error = $error.'<li>' . __('Empty field "material"') . '</li>'."\n";
		else if (mb_strlen($edit) > Config::read('max_lenght', 'stat'))
			$error = $error.'<li>' . sprintf(__('Wery big "material"'), Config::read('max_lenght', 'stat')) . '</li>'."\n";
		if (!empty($tags) && !$valobj->cha_val($tags, V_TITLE)) 
			$error = $error.'<li>' . __('Wrong chars in "tags"') . '</li>'."\n";
		if (!empty($sourse) && !$valobj->cha_val($sourse, V_TITLE)) 
			$error = $error.'<li>' . __('Wrong chars in "sourse"') . '</li>'."\n";
		if (!empty($sourse_email) && !$valobj->cha_val($sourse_email, V_MAIL)) 
			$error = $error.'<li>' . __('Wrong chars in "email"') . '</li>'."\n";
		if (!empty($sourse_site) && !$valobj->cha_val($sourse_site, V_URL)) 
			$error = $error.'<li>' . __('Wrong chars in "sourse site"') . '</li>'."\n";


		// Errors
		if (!empty( $error )) {
			$_SESSION['FpsForm'] = array_merge(array('title' => null, 'mainText' => null, 
				'description' => null, 'tags' => null, 'sourse' => null, 'sourse_email' => null, 
				'sourse_site' => null, 'commented' => null, 'available' => null), $_POST);
			$_SESSION['editForm']['error']   = '<p class="errorMsg">' . __('Some error in form') . '</p>'
			."\n".'<ul class="errorMsg">'."\n".$error.'</ul>'."\n";
			redirect('/stat/edit_form/' . $id );
		}
		
		$in_cat = (int)$_POST['cats_selector'];
		$sql = $this->DB->select('stat_sections', DB_FIRST, array('cond' => array('id' => $in_cat)));
		$info_cat = $sql[0];
		if (!$this->ACL->turn(array('stat', 'record_comments_management'), false)) $commented = '1';
		if (!$this->ACL->turn(array('stat', 'hide_material'), false)) $available = '1';
		
		
		// Запрос на обновление новости
		$edit = mb_substr($edit, 0, Config::read('max_lenght', 'stat'));
		$res = $this->DB->save('stat', array(
			'title'       => $title,
			'main'        => $edit,
			'category_id' => $info_cat['id'],
			'section_id'  => $info_cat['section_id'],
			'description'  => $description,
			'tags'         => $tags,
			'sourse'  	   => $sourse,
			'sourse_email' => $sourse_email,
			'sourse_site'  => $sourse_site,
			'commented'    => $commented,
			'available'    => $available,
			'id'          => $id
		));
		if (is_object($this->AddFields)) {
			$this->AddFields->save($id, $_addFields);
		}
		
		//clean cache
		$this->Cache->clean(CACHE_MATCHING_TAG, array('module_stat', 'record_id_' . $id));
		$this->DB->cleanSqlCache();
		if ($this->Log) $this->Log->write('editing stat', 'stat id(' . $id . ')');
		return showInfoMessage(__('Operation is successful'), '/stat/' );

	}





	// Функция удаляет тему; ID темы передается методом GET
	function delete($id = null) {	
		$this->cached = false;
		// Если новость пытается удалить не зарегистрированный пользователь
		if ( empty( $id ) ) {
			redirect('/');
		}
		$id = (int)$id;
		if ( $id < 1 ) {
			redirect('/');
		}
		
		$sql = $this->DB->select('stat', DB_FIRST, array('cond' => array('id' => $id)));
		$result = $sql[0];

		if (!$this->ACL->turn(array('stat', 'delete_materials')) 
		|| (!empty($_SESSION['user']['id']) && $result['author_id'] == $_SESSION['user']['id'] 
		&& !$this->ACL->turn(array('stat', 'delete_mine_materials')))) {
			return showInfoMessage(__('Permission denied'), '/stat/' );
		}
		// Теперь удаляем материал 
		$res = $this->DB->query("DELETE FROM `" . $this->DB->getFullTableName('stat') . "` WHERE `id` = '" . $id . "'");	
		$this->DB->query("DELETE FROM `" . $this->DB->getFullTableName('stat_add_content') . "` WHERE `entity_id` = '" . $id . "'");
		
		//clean cache
		$this->Cache->clean(CACHE_MATCHING_TAG, array('module_stat'));
		$this->DB->cleanSqlCache();
		if ($this->Log) $this->Log->write('delete stat', 'stat id(' . $id . ')');
		return showInfoMessage(__('Material has been delete'), '/stat/' );
	}


	
	
	
	
	/**
	* add comment to stat
	*
	* @id (int)    stat ID
	* @return      info message
	*/
	public function add_comment($id = null) {
		include_once(R . 'sys/inc/includes/add_comment.php');
	}
	
	
	/**
	* add comment form to stat
	*
	* @id (int)    stat ID
	* @return      html form
	*/
	private function _add_comment_form($id = null) {
		include_once(R . 'sys/inc/includes/_add_comment_form.php');
		return $html;
	}
	
	
	
	/**
	* edit comment form to stat
	*
	* @id (int)    comment ID
	* @return      html form
	*/
	public function edit_comment_form($id = null) {
		include_once(R . 'sys/inc/includes/edit_comment_form.php');
	}
	
	
	
	/**
	* update comment
	*
	* @id (int)    comment ID
	* @return      info message
	*/
	public function update_comment($id = null) {
		include_once(R . 'sys/inc/includes/update_comment.php');
	}
	
	
	
	/**
	* get comments for stat
	*
	* @id (int)    stat ID
	* @return      html comments list
	*/
	private function _get_comments($id = null) {
		include_once(R . 'sys/inc/includes/_get_comments.php');
		return $html;
	}
	
	
	
	/**
	* delete comment
	*
	* @id (int)    comment ID
	* @return      info message
	*/
	public function delete_comment($id = null) {
		include_once(R . 'sys/inc/includes/delete_comment.php');
	}
	
	
	
	
	
	
	/**
	* @param int $id - record ID
	*
	* update date by record also up record in recods list
	*/
	public function upper($id) {
		$this->ACL->turn(array('stat', 'up_materials'));
		$id = (int)$id;
		if ($id < 1) {
			redirect('/');
		}
		$this->DB->save('stat', array('id' => $id, 'date' => new Expr('NOW()')));
		return showInfoMessage(__('Operation is successful'), '/stat/');
	}
	
	
	
	/**
	* @param int $id - record ID
	*
	* allow record be on home page
	*/
	public function on_home($id) {
		$this->ACL->turn(array('stat', 'on_home'));
		$id = (int)$id;
		if ($id < 1) {
			redirect('/');
		}
		$this->DB->save('stat', array('id' => $id, 'view_on_home' => 1));
		return showInfoMessage(__('Operation is successful'), '/stat/');
	}
	
	
	/**
	* @param int $id - record ID
	*
	* denied record be on home page
	*/
	public function off_home($id) {
		$this->ACL->turn(array('stat', 'on_home'));
		$id = (int)$id;
		if ($id < 1) {
			redirect('/');
		}
		$this->DB->save('stat', array('id' => $id, 'view_on_home' => 0));
		return showInfoMessage(__('Operation is successful'), '/stat/');
	}
	
	
	
	/**
	* @param int $id - record ID
	*
	* fix or unfix record on top on home page
	*/
	public function fix_on_top($id) {
		$this->ACL->turn(array('stat', 'on_home'));
		$id = (int)$id;
		if ($id < 1) {
			redirect('/');
		}
		$target = $this->DB->select('stat', DB_FIRST, array('cond' => array('id' => $id)));
		if (empty($target[0])) redirect('/');
		$dest = ($target[0]['on_home_top'] == '1') ? '0' : '1';
		$this->DB->save('stat', array('id' => $id, 'on_home_top' => $dest));
		return showInfoMessage(__('Operation is successful'), '/stat/');
	}
	
	
	
	/**
	* @param array $record - assoc record array
	* @return string - admin buttons
	*
	* create and return admin bar
	*/
	protected function _getAdminBar($record) {
		$moder_panel = '';
		if ($this->ACL->turn(array('stat', 'edit_materials'), false) 
		|| (!empty($_SESSION['user']['id']) && $record['author_id'] == $_SESSION['user']['id'] 
		&& $this->ACL->turn(array('stat', 'edit_mine_materials'), false))) {
			$moder_panel .= get_link(get_img('/sys/img/edit_16x16.png'), '/stat/edit_form/' . $record['id']) . '&nbsp;';
		}
		
		if ($this->ACL->turn(array('stat', 'up_materials'), false)) {
			$moder_panel .= get_link(get_img('/sys/img/star.png'), 
			'/stat/fix_on_top/' . $record['id'], array('onClick' => "return confirm('" . __('Are you sure') . "')")) . '&nbsp;';
			$moder_panel .= get_link(get_img('/sys/img/up_arrow_16x16.png'), 
			'/stat/upper/' . $record['id'], array('onClick' => "return confirm('" . __('Are you sure') . "')")) . '&nbsp;';
		}
		if ($this->ACL->turn(array('stat', 'on_home'), false)) {
				if ($record['view_on_home'] == 1) {
					$moder_panel .= get_link(get_img('/sys/img/round_ok.png', array('title' => __('On home'))), 
					'/stat/off_home/' . $record['id'], array('onClick' => "return confirm('" . __('Are you sure') . "')")) . '&nbsp;';
				} else {
					$moder_panel .= get_link(get_img('/sys/img/round_not_ok.png', array('title' => __('On home'))), 
					'/stat/on_home/' . $record['id'], array('onClick' => "return confirm('" . __('Are you sure') . "')")) . '&nbsp;';
				}
		}
		
		if ($this->ACL->turn(array('stat', 'delete_materials'), false) 
		|| (!empty($_SESSION['user']['id']) && $record['author_id'] == $_SESSION['user']['id'] 
		&& $this->ACL->turn(array('stat', 'delete_mine_materials'), false))) {
			$moder_panel .= get_link(get_img('/sys/img/delete_16x16.png'), 
			'/stat/delete/' . $record['id'], array('onClick' => "return confirm('" . __('Are you sure') . "')")) . '&nbsp;';
		}
		return $moder_panel;
	}
	
	
	

    /**
     * RSS for news
	 *
     */
    function rss() {
		include_once R . 'sys/inc/includes/rss.php';
    }	
	
}
?>