<?php
##################################################
##												##
## Author:       Andrey Brykin (Drunya)         ##
## Version:      0.7                            ##
## Project:      CMS                            ##
## package       CMS Fapos                      ##
## subpackege    ACL library                    ##
## copyright     ©Andrey Brykin 2010-2011       ##
##################################################


##################################################
##												##
## any partial or not partial extension         ##
## CMS Fapos,without the consent of the         ##
## author, is illegal                           ##
##################################################
## Любое распространение                        ##
## CMS Fapos или ее частей,                     ##
## без согласия автора, является не законным    ##
##################################################

//rules and groups files
include_once R . 'sys/settings/acl_rules.php';
include_once R . 'sys/settings/acl_groups.php';


class ACL {

	private $rules;
	public $groups;


	public function __construct() {
		global $acl_rules, $acl_groups;
		$this->rules = $acl_rules;
		$this->groups = $acl_groups;
	}


	public function turn($params, $redirect = true, $group = false) {
		if ($group === false) {
			$user_group = (!empty($_SESSION['user']['status'])) ? $_SESSION['user']['status'] : 0;
		} else {
			$user_group = (int)$group;
		}
		
		if (!isset($this->rules[$params[0]]) || !is_array($this->rules[$params[0]])) return false;
		switch (count($params)) {
			case 1:
				$access = (bool)in_array($user_group, $this->rules[$params[0]]);
				break;
			case 2:
				$access = (bool)in_array($user_group, $this->rules[$params[0]][$params[1]]);
				break;
			default:
				$access = false;
				break;
		}
		if (!$access && $redirect) {
			redirect('/error.php?ac=403');
		} else {
			return $access;
		}
	}
	
	
	/**
	*
	*/
	public function save_rules($rules) {
		if ($fopen = fopen(R . 'sys/settings/acl_rules.php', 'w')) {
			fputs($fopen, '<?php ' . "\n" . '$acl_rules = ' . var_export($rules, true) . "\n" . '?>');
			fclose($fopen);
			return true;
		} else {
			return false;
		}
	}
	
	
	/**
	*
	*/
	public function save_groups($groups) {
		if ($fopen=@fopen(R . 'sys/settings/acl_groups.php', 'w')) {
			@fputs($fopen, '<?php ' . "\n" . '$acl_groups = ' . var_export($groups, true) . "\n" . '?>');
			@fclose($fopen);
			return true;
		} else {
			return false;
		}
	}
	
	
	/**
	* @return user group info
	*/
	public function get_group_info() {
		global $acl_groups;
		return $acl_groups;
	}
	
	
	/**
	* @param int $id - user group ID
	*
	* @return string group title
	*/
	public function get_user_group($id) {
		global $acl_groups;
		if (!empty($acl_groups[$id])) return $acl_groups[$id];
		return false;
	}
	

}
?>