<?php

$cache_key = $this->module . '_rss';
$cache_tags = array(
	'module_' . $this->module,
	'action_rss',
);

if (!Config::read('rss_' . $this->module, 'common')) redirect('/');

if ($this->Cache->check($cache_key)) {
	$html = $this->Cache->read($cache_key);
	
	
} else {
	$sitename = '/';
	if (!empty($_SERVER['SERVER_NAME'])) {
		$sitename = 'http://' . $_SERVER['SERVER_NAME'] . '';
	}
	
	$html = '<?xml version="1.0" encoding="UTF-8"?>';
	$html .= '<rss version="2.0">';
	$html .= '<channel>';
	$html .= '<title>' . h(Config::read('title', $this->module)) . '</title>';
	$html .= '<link>' . $sitename . $this->module . '/</link>';
	$html .= '<description>' . h(Config::read('description', $this->module)) . '</description>';
	$html .= '<pubDate>' . date('r') . '</pubDate>';
	$html .= '<generator>FPS RSS Generator (Fapos CMS)</generator>';

	// Get records
	$materials = $this->DB->select($this->module, DB_ALL, array(
		'joins' => array(
			array(
				'table' => $this->module . '_sections',
				'type' => 'LEFT',
				'alias' => 'b',
				'cond' => 'a.`category_id` = b.`id`',
			),
			array(
				'table' => $this->module . '_sections',
				'type' => 'LEFT',
				'alias' => 'c',
				'cond' => 'b.`section_id` = c.`id`',
			),
			array(
				'table' => 'users',
				'type' => 'LEFT',
				'alias' => 'd',
				'cond' => 'd.`id` = a.`author_id`',
			),
		),
		'fields' => array('a.*', 'b.`title` as category_name', 'b.`section_id` as section_id', 'c.`title` as section_name', 'd.`name` AS author'),
		'alias' => 'a',
		'order' => 'a.`date` DESC',
		'limit' => Config::read('rss_cnt', 'common'),
	));
		
	//pr($materials);
		
	// Build list
	if (!empty($materials)) { 
		$html .= '<lastBuildDate>' . date('r', strtotime($materials[0]['date'])) . '</lastBuildDate>';
		foreach ($materials as $record) { 
			$html .= '<item>';
			$html .= '<link>' . $sitename . get_url(entryUrl($record, $this->module)) . '</link>';
			$html .= '<pubDate>' . date('r', strtotime($record['date'])) . '</pubDate>';
			$html .= '<title>' . $record['title'] . '</title>';
			$html .= '<description><![CDATA[' . mb_substr($record['main'], 0, Config::read('rss_lenght', 'common')) . '<br />';
			$html .= 'Автор: ' . $record['author'] . '<br />]]></description>';
			$html .= '<category>' . $record['category_name'] . '</category>';
			$html .= '<guid>' . $sitename . $this->module . '/view/' . $record['id'] . '</guid>';
			$html .= '</item>';
		}
	}


	$html .= '</channel>';
	$html .= '</rss>';
	
	$this->Cache->write($html, $cache_key, $cache_tags);
}

echo $html;

?>